unit DevILAboutFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, ShellAPI,
  StdCtrls, Buttons, ExtCtrls, jpeg;

type
  TDevILAboutForm = class(TForm)
    LabelEmail: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    ExitBtn: TBitBtn;
    SFLabel: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LicenseLabel: TLabel;
    Image1: TImage;
    procedure ExitBtnClick(Sender: TObject);
    procedure LabelEmailClick(Sender: TObject);
    procedure SFLabelClick(Sender: TObject);
    procedure LicenseLabelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DevILAboutForm: TDevILAboutForm;

implementation
uses TongGlobals;
{$R *.DFM}


procedure TDevILAboutForm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;


procedure TDevILAboutForm.LabelEmailClick(Sender: TObject);
begin
  ShellExecute(handle,'open','mailto:denton@imagelib.org',nil,nil,SW_SHOWNORMAL);
end;

procedure TDevILAboutForm.SFLabelClick(Sender: TObject);
begin
  ShellExecute(handle,'open','http://openil.sourceforge.net/',nil,nil,SW_SHOWNORMAL);
end;

procedure TDevILAboutForm.LicenseLabelClick(Sender: TObject);
begin
  ShellExecute(handle,'open','http://openil.sourceforge.net/license.php',nil,nil,SW_SHOWNORMAL);
end;

procedure TDevILAboutForm.FormCreate(Sender: TObject);
begin
  left := DevILAboutX;
  top := DevILAboutY;
end;

procedure TDevILAboutForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DevILAboutX := DevILAboutForm.left;
  DevILAboutY := DevILAboutForm.top;
end;

end.
