unit DevILInfoFrm;

interface

uses Windows, SysUtils, Classes, Graphics,
  Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TDevILInfoDlg = class(TForm)
    OKBtn: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    NameLabel: TLabel;
    DepthLabel: TLabel;
    WidthLabel: TLabel;
    SizeLabel: TLabel;
    HeightLabel: TLabel;
    VersionNumberLabel: TLabel;
    VersionLabel: TLabel;
    VendorLabel: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DevILInfoDlg: TDevILInfoDlg;

implementation

uses TongGlobals, DevILFrm;

{$R *.DFM}
procedure TDevILInfoDlg.FormCreate(Sender: TObject);
begin
  top := DevILInfoY;
  left := DevILInfoX;
end;

procedure TDevILInfoDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DevILInfoY := DevILInfoDlg.top;
  DevILInfoX := DevILInfoDlg.left;
end;

procedure TDevILInfoDlg.FormShow(Sender: TObject);
begin
  VendorLabel.Caption:=DDevILForm.IDC_ABOUT_VENDOR;
  VersionLabel.Caption:=DDevILForm.IDC_ABOUT_VER_STRING;
  VersionNumberLabel.Caption:=Inttostr(DDevILForm.IDC_ABOUT_VER_NUM);

  NameLabel.Caption:=DDevILForm.CurFileName;
  WidthLabel.Caption:=Inttostr(DDevILForm.IDC_PROP_WIDTH);
  HeightLabel.Caption:=Inttostr(DDevILForm.IDC_PROP_HEIGHT);
  DepthLabel.Caption:=Inttostr(DDevILForm.IDC_PROP_DEPTH);
  SizeLabel.Caption:=Inttostr(DDevILForm.IDC_PROP_SIZE);
end;



end.
