unit Srchfrm;

{WinTidy - program to clear out unwanted files
Showman,
FileFinder
link to Disk Hog}

interface

uses
  Windows, Messages, SysUtils, Classes, Printers,
  Graphics, Controls, Forms, Dialogs,ShellApi,
  StdCtrls, FileCtrl, ExtCtrls, Buttons, ShowFileInfo,
  ComCtrls, TeEngine, Series, TeeProcs, Chart;

type
  TSrchForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    btnFinder: TSpeedButton;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    btnExit: TSpeedButton;
    SearchModeRG: TRadioGroup;
    chFileName: TCheckBox;
    chExtension: TCheckBox;
    chSubFoldersToo: TCheckBox;
    chNewerThan: TCheckBox;
    chOlderThan: TCheckBox;
    chLargerThan: TCheckBox;
    chSmallerThan: TCheckBox;
    dtpOlderThan: TDateTimePicker;
    dtpNewerThan: TDateTimePicker;
    edtLargerThan: TEdit;
    Edit1: TEdit;
    udLargerThan: TUpDown;
    edtSmallerThan: TEdit;
    Edit2: TEdit;
    udSmallerThan: TUpDown;
    FillVectorBtn: TButton;
    FillRasterBtn: TButton;
    FillDEMBtn: TButton;
    DirectoryListBox: TDirectoryListBox;
    DriveComboBox: TDriveComboBox;
    TabSheet4: TTabSheet;
    lblSearchedFolders: TLabel;
    lblSearchedFiles: TLabel;
    lblFoundFiles: TLabel;
    lblTotalFoundSize: TLabel;
    FFListView: TListView;
    btnHelp: TSpeedButton;
    btnInfo: TSpeedButton;
    SrcFilenameEdit: TEdit;
    FillTrashBtn: TButton;
    ReadOnlyCB: TCheckBox;
    ArchiveCB: TCheckBox;
    SystemCB: TCheckBox;
    HiddenCB: TCheckBox;
    ExtMemo: TMemo;
    lblSize: TLabel;
    Label1: TLabel;
    HintsPanel: TPanel;
    ListBox: TListBox;
    btnSelectAll: TSpeedButton;
    btnDelete: TSpeedButton;
    SaveList: TSpeedButton;
    PrintList: TSpeedButton;
    ViewList: TSpeedButton;
    SetDateBtn: TSpeedButton;
    SetAttributeBtn: TSpeedButton;
    SFLabel: TLabel;
    FFLabel: TLabel;
    SFilesLabel: TLabel;
    TFSLabel: TLabel;
    SaveResultListBtn: TSpeedButton;
    PrintResultListBtn: TSpeedButton;
    FilenameCB: TCheckBox;
    DirCB: TCheckBox;
    TypeCB: TCheckBox;
    BytesCB: TCheckBox;
    AttCB: TCheckBox;
    DateCB: TCheckBox;
    PathFirstCB: TCheckBox;
    Allon1lineCB: TCheckBox;
    ResultSelectAllBtn: TSpeedButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ClearExtBtn: TSpeedButton;
    ShowFileSizeTS: TTabSheet;
    Chart1: TChart;
    Series1: TPieSeries;
    TotalLabel: TLabel;
    ResultstoList: TSpeedButton;
    PrintChartBtn: TSpeedButton;
    SFSHelpBtn: TSpeedButton;
    CloseBtn: TSpeedButton;
    SFSListBox: TListBox;
    SFSDirectoryListBox: TDirectoryListBox;
    SFSDriveComboBox: TDriveComboBox;
    ShowSlackCB: TCheckBox;
    OpentoscanBtn: TSpeedButton;
    btnSearch: TSpeedButton;
    btnStop: TSpeedButton;
    btnUp: TSpeedButton;
    SFSInfo: TSpeedButton;
    DoDirCB: TCheckBox;
    DoSizeCB: TCheckBox;
    SFSSave: TSpeedButton;
    SFSPrint: TSpeedButton;
    SFSView: TSpeedButton;
    SFSSubCB: TCheckBox;
    DatabaseSelectedBtn: TSpeedButton;
    TabSheet1: TTabSheet;
    ActivateHogHunterBtn: TSpeedButton;
    Label2: TLabel;
    JumpLabel: TLabel;
    Label5: TLabel;
    Image2: TImage;
    ListListBtn: TSpeedButton;
{procedure InitShow;}
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure DirectoryListBoxChange(Sender: TObject);
    procedure btnFinderClick(Sender: TObject);
procedure  SearchAllfiles(root: string);
procedure  SearchName(root: string);
procedure  SearchTypeExt(root: string);
procedure  SearchAttribute(root: string);
procedure  SearchDate(root: string);
procedure  SearchSize(root: string);
procedure  SearchAllCriteria(root: string);
    procedure ListBoxClick(Sender: TObject);
    procedure btnSelectAllClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
procedure FillMemoExt(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnHelpClick(Sender: TObject);
    procedure btnInfoClick(Sender: TObject);
    procedure ViewListClick(Sender: TObject);
    procedure PrintListClick(Sender: TObject);
    procedure SaveListClick(Sender: TObject);
procedure AnyUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure DriveComboBoxChange(Sender: TObject);
    procedure SetAttributeBtnClick(Sender: TObject);
    procedure SetDateBtnClick(Sender: TObject);
    procedure FFListViewClick(Sender: TObject);
    procedure FFListViewColumnClick(Sender: TObject; Column: TListColumn);
    procedure FFListViewCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure FFListViewDblClick(Sender: TObject);
    procedure SaveResultListBtnClick(Sender: TObject);
    procedure PrintResultListBtnClick(Sender: TObject);
    procedure ResultSelectAllBtnClick(Sender: TObject);
    procedure ClearExtBtnClick(Sender: TObject);
    procedure OpentoscanBtnClick(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure SFSListBoxDblClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnUpClick(Sender: TObject);
    procedure SFSHelpBtnClick(Sender: TObject);
    procedure Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure ShowSlackCBClick(Sender: TObject);
    procedure PrintChartBtnClick(Sender: TObject);
    procedure ResultstoListClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure SFSInfoClick(Sender: TObject);
procedure scan_tree;
procedure handle_double_click (entry: TDirectoryData);
procedure display_list (const list: TDirectoryList);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
procedure ShowHint(Sender: TObject);
    procedure SFSViewClick(Sender: TObject);
    procedure SFSPrintClick(Sender: TObject);
    procedure SFSSaveClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure SFSDirectoryListBoxChange(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure DatabaseSelectedBtnClick(Sender: TObject);
    procedure ActivateHogHunterBtnClick(Sender: TObject);
    procedure JumpLabelClick(Sender: TObject);
    procedure ListListBtnClick(Sender: TObject);
  private
    { Private declarations }
    scanning: boolean;
    stop_requested: boolean;
    files_found: integer;
    KB_found: integer;
    DirSearched,   FilesSearched: integer;
{    procedure scan_tree (root: string); }
    dir_list: TDirectoryList;
    show_allocated: boolean;
  protected

  public
    { Public declarations }
       SortBy   : integer;
  end;
procedure set_status_text (const s: string);  stdcall;
var
  SrchForm: TSrchForm;

implementation
uses   TongGlobals, PicAbout, PicView, GBfrm,
       GListFrm, AJCsvDbFrm, szMain, TongsFrm;

{$R *.DFM}

const
{ KBYTE  = Sizeof(Byte) shl 10;
 MBYTE  = KBYTE        shl 10; }
  FILENAME_ID         = 0;
  FOLDER_ID           = 1;
  FILETYPE_ID         = 2;
  SIZE_ID             = 3;
  ATTRIBUTES_ID       = 4;
  CREATION_TIME_ID    = 5;
var
BytesBaby:Integer;

procedure TSrchForm.FormCreate(Sender: TObject);
var
  params: string;
 SFI : TSHFileInfo;
begin
  top := SrchFormY;
  left := SrchFormX;
  dir_list := TDirectoryList.Create (nil, '.');
  show_allocated := True;
  scanning := False;
  btnDelete.Enabled := False;
  btnSelectAll.Enabled := False;
  stop_requested := False;
  dtpNewerThan.Date := FileDateToDateTime(FileAge( Application.ExeName));
  If FileExists('C:\Command.com') then
  dtpOlderThan.Date := FileDateToDateTime(FileAge( 'C:\Command.com'{Autoexec.bat'} ))
  else dtpOlderThan.Date := FileDateToDateTime(FileAge( 'C:\Autoexec.bat' ));
  edtLargerThan.Text :=  Format('%f', [( udLargerThan.Position * 1000) / 1000000]);
  edtSmallerThan.Text := Format('%f', [( udSmallerThan.Position * 1000) / 1000000]);
  ExtMemo.Text := '*.*';
  SrcFilenameEdit.Text := ExtractFileName(Application.ExeName);
{  files_to_find := normal;}
  { connect the system image list to the ListView }
  with FFListView do
  begin
    SmallImages := TImageList.CreateSize(16,16);
    SmallImages.ShareImages := True;
    SmallImages.Handle := ShGetFileInfo('*.*',
                                         0,
                                         SFI,
                                         SizeOf(SFI),
                                         SHGFI_SMALLICON
                                         or SHGFI_ICON
                                         or SHGFI_SYSICONINDEX);

    LargeImages := TImageList.Create(nil);
    LargeImages.ShareImages := True;
    LargeImages.Handle := ShGetFileInfo('*.*',
                                         0,
                                         SFI,
                                         SizeOf(SFI),
                                         SHGFI_LARGEICON
                                         or SHGFI_ICON
                                         or SHGFI_SYSICONINDEX);

  end;
  if ParamCount > 0 then
    begin
    params := ParamStr (1);
    DriveComboBox.Drive := params [1];
    DirectoryListBox.Directory := params;
    end;
end;
procedure TSrchForm.FormShow(Sender: TObject);
begin
{}  Application.OnHint := ShowHint;
end;
procedure TSrchForm.FormHide(Sender: TObject);
begin
  Application.OnHint := TongsForm.ShowHint;
end;
procedure TSrchForm.ShowHint(Sender: TObject);
begin
  HintsPanel.Caption := Application.Hint;
end;
procedure TSrchForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If TongsAlreadyGone then
  begin
  SrchFormY := SrchForm.top;
  SrchFormX := SrchForm.left;
    FFListView.Items.Clear;
    FFListView.SmallImages.Free;
    FFListView.LargeImages.Free;
    dir_list.Free;
    Application.ProcessMessages;
    Action := caFree;
  end else Action:=caHide;
end;
procedure TSrchForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  stop_requested := True;
end;
procedure TSrchForm.btnExitClick(Sender: TObject);
begin
  stop_requested := True;        // to stop the scanning loop
  Close;
end;

procedure TSrchForm.AnyUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
  edtLargerThan.Text :=  Format('%f', [( udLargerThan.Position * 1024 ) / 1048576]);
  edtSmallerThan.Text := Format('%f', [( udSmallerThan.Position * 1024) / 1048576]);
end;

procedure TSrchForm.DriveComboBoxChange(Sender: TObject);
begin
  DirectoryListBox.Drive := DriveComboBox.Drive;
end;
procedure TSrchForm.DirectoryListBoxChange(Sender: TObject);
begin
  SrchForm.Caption := 'Snake Show: ' +(DirectoryListBox.Directory);
end;
procedure TSrchForm.SFSDirectoryListBoxChange(Sender: TObject);
begin
 SrchForm.Caption := 'Snake Show: ' + (SFSDirectoryListBox.Directory);
end;
procedure TSrchForm.FormActivate(Sender: TObject);
begin
  SrchForm.Caption := 'Snake Show: ' + DirectoryListBox.Directory;
end;


procedure TSrchForm.ListBoxClick(Sender: TObject);
begin
  If ListBox.Items.Count >0 then
  begin
  btnDelete.Enabled := ListBox.SelCount <> 0;
  SetAttributeBtn.Enabled := ListBox.SelCount <> 0;
  SetDateBtn.Enabled := ListBox.SelCount <> 0;
  SaveList.Enabled := ListBox.SelCount <> 0;
  PrintList.Enabled := ListBox.SelCount <> 0;
  ViewList.Enabled := ListBox.SelCount <> 0;
  End;
end;

procedure TSrchForm.btnFinderClick(Sender: TObject);
begin
  if scanning
  then stop_requested := True
  else
  begin
    btnFinder.Caption := 'Stop';
    btnDelete.Enabled := False;
    btnSelectAll.Enabled := False;
    SetAttributeBtn.Enabled  := False;
    SetDateBtn.Enabled := False;
    SaveList.Enabled := False;
    PrintList.Enabled := False;
    ViewList.Enabled := False;
    SaveResultListBtn.Enabled := False;
    PrintResultListBtn.Enabled := False;
    lblSize.Caption := '';
    Label1.Caption := '';
    ListBox.Clear;
    FFListView.Items.Clear;
    scanning := True;
    stop_requested := False;
    DriveComboBox.Enabled := False;
    DirectoryListBox.Enabled := False;
    files_found := 0;
    KB_found := 0;
    BytesBaby:=0;
    FilesSearched:= 0;
    DirSearched:= 1;
    try

case SearchModeRG.Itemindex of
0: SearchAllfiles(DirectoryListBox.Directory);
1: SearchName(DirectoryListBox.Directory);
2: SearchTypeExt(DirectoryListBox.Directory);
3: SearchAttribute(DirectoryListBox.Directory);
4: SearchDate(DirectoryListBox.Directory);
5: SearchSize(DirectoryListBox.Directory);
6: SearchAllCriteria(DirectoryListBox.Directory);
end;{case}

    finally
    end;
    scanning := False;
    DriveComboBox.Enabled := True;
    DirectoryListBox.Enabled := True;
    btnFinder.Caption := 'Find';
    btnSelectAll.Enabled := True;
    if files_found <> 0
    then
      begin
      Label1.Caption := Inttostr(files_found)+' Candidates for ...';
      HintsPanel.Caption := '';
      btnSelectAll.Enabled := True;
      SFLabel.Caption := Inttostr(DirSearched);
      SFilesLabel.Caption := Inttostr(FilesSearched);
      FFLabel.Caption:=Inttostr(files_found);
      TFSLabel.Caption:=
         Format('%f MB', [((BytesBaby/1048576))]{[KB_found / 1000]});
      end
    else
      begin
      Label1.Caption := '';
      HintsPanel.Caption := 'No files found';
      btnSelectAll.Enabled := False;
      SFLabel.Caption := Inttostr(DirSearched);
      SFilesLabel.Caption := Inttostr(FilesSearched);
      FFLabel.Caption:=Inttostr(files_found);
      TFSLabel.Caption:=
          Format('%f MB', [((BytesBaby/1024)/1024)]{[KB_found / 1000]});
      end;
    DoMessages(40001);
    end;
end;

function Get_FileTypeAndIconIndex(FileName:string;
                              var FileType: string ):integer;
var
  Ext : string;
  SFI : TSHFileInfo;
begin
  Ext := FileName;
  ShGetFileInfo(PChar(Ext),
                0,
                SFI,
                SizeOf(SFI),
                SHGFI_SMALLICON
                or  SHGFI_SYSICONINDEX
                or SHGFI_TYPENAME);
  FileType := String(SFI.szTypeName);
  Result   := SFI.iIcon;
End;

procedure TSrchForm.FFListViewColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  if FFListView.Items.Count > 0
  then
  begin
  SortBy := Column.ID;
  FFListView.AlphaSort;
  end;
end;

{  FILENAME_ID         = 0;
  FOLDER_ID           = 1;
  FILETYPE_ID         = 2;
  SIZE_ID             = 3;
  ATTRIBUTES_ID       = 4;
  CREATION_TIME_ID    = 5;}
procedure TSrchForm.FFListViewCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
var
 S1,
 S2 : string;
 I1,
 I2 :integer;
begin
I1 :=2;
I2 :=1; {shut up compiler}
  case SortBy of
    FILENAME_ID         : begin
                          S1 := Item1.Caption;
                          S2 := Item2.Caption;
                          end;
    FOLDER_ID           ,
    FILETYPE_ID         : begin S1 := Item1.SubItems[SortBy - 1];
                                S2 := Item2.SubItems[SortBy - 1];  end;

    SIZE_ID             : begin
                            S1 := Item1.SubItems[SortBy - 1];
                            S2 := Item2.SubItems[SortBy - 1];
                            S1 := StringOfChar('0', 15) + S1;
                            S2 := StringOfChar('0', 15) + S2;
                            S1 := Copy(S1, Length(S1) - 15, 16);
                            S2 := Copy(S2, Length(S2) - 15, 16);
                           end;

    ATTRIBUTES_ID         : begin S1 := Item1.SubItems[SortBy - 1];
                                S2 := Item2.SubItems[SortBy - 1];  end;
    CREATION_TIME_ID: begin
                            I1 := DateTimeToFileDate(StrToDateTime(Item1.SubItems[SortBy - 1]));
                            I2 := DateTimeToFileDate(StrToDateTime(Item2.SubItems[SortBy - 1]));
                          end;
  end;

  if SortBy < CREATION_TIME_ID
  then
    begin
      if S1 = S2 then Compare := 0;
      if S1 < S2 then Compare := -1;
      if S1 > S2 then Compare := 1;
    end
  else
    begin
      if I1 = I2 then Compare := 0;
      if I1 > I2 then Compare := -1;
      if I1 < I2 then Compare := 1;
    end;
end;

procedure TSrchForm.SearchAllfiles(root: string);
var
AttrS,  test_name,full_name,FileTypePassed: string;
  s: TSearchRec;
  KB: integer;
  ListItem       : TListItem;
begin
  if stop_requested then Exit;
  root := LowerCase (root);
  HintsPanel.Caption := 'Searching ' + root + '...';
  if root [Length (root)] <> '\' then root := root + '\';
    Application.ProcessMessages;
    if FindFirst (root+'*.*', faAnyFile, s) = 0 then
    repeat   Inc(FilesSearched);
      if stop_requested then Exit;
      with s do
        begin
        test_name := LowerCase (Name);
        if (Attr <> faDirectory) then
          begin   {skips problem of Directory NOT having dates}
          full_name := root + test_name;
          KB := (Size + 1023) div 1024;
          Inc (files_found);
          Inc (KB_found, KB);
          BytesBaby:=BytesBaby+Size;
          lblSize.Caption := IntToStr (KB_found) + ' KB';
          ListBox.Items.Add (Format ('%5d  ', [KB]) + full_name);
    with FFListView do
    begin
      ListItem := Items.Add;
      ListItem.ImageIndex:=
        Get_FileTypeAndIconIndex(root + test_name,
                 FileTypePassed);
      ListItem.Caption := test_name;
      ListItem.SubItems.Add(root);
      ListItem.SubItems.Add(FileTypePassed);
      ListItem.SubItems.Add(Inttostr(Size));
      AttrS:=' ';
      If (Attr and faReadOnly > 0) then AttrS:=AttrS+'R';
      If (Attr and faArchive	> 0) then AttrS:=AttrS+'A';
      If (Attr and faSysFile  > 0) then AttrS:=AttrS+'S';
      If (Attr and faHidden   > 0) then AttrS:=AttrS+'H';
      ListItem.SubItems.Add(AttrS{Inttostr(Attr)});
      ListItem.SubItems.Add(DateTimeToStr(FileDateToDateTime(Time)));
    end;
          end;
        end;
    until FindNext (s) <> 0;
    FindClose (s);
If chSubFoldersToo.Checked then
begin
  test_name := root + '*.*';
  if FindFirst (test_name, faAnyFile, s) = 0 then
  repeat
    with s do
      if ((Attr and faDirectory) <> 0)
         and ((Name <> '.') and (Name <> '..'))
        then
        begin
        inc(DirSearched);
        SearchAllfiles(root + Name);
        end;
  until FindNext (s) <> 0;
  FindClose (s);
end;
end;

procedure TSrchForm.SearchName(root: string);
var
AttrS,  test_name,full_name,FileTypePassed: string;
  s: TSearchRec;
  KB: integer;
  ListItem       : TListItem;
begin
  if stop_requested then Exit;
  root := LowerCase (root);
  HintsPanel.Caption := 'Searching ' + root + '...';
  if root [Length (root)] <> '\' then root := root + '\';
    Application.ProcessMessages;
    if FindFirst (root+SrcFilenameEdit.Text, faAnyFile, s) = 0 then
    repeat   Inc(FilesSearched);
      if stop_requested then Exit;
      with s do
        begin
        test_name := LowerCase (Name);
        If  (test_name = LowerCase (SrcFilenameEdit.Text))then
        begin
        if (Attr <> faDirectory) then
          begin   {skips problem of Directory NOT having dates}
          full_name := root + test_name;
          KB := (Size + 1023) div 1024;
          Inc (files_found);
          Inc (KB_found, KB);
          BytesBaby:=BytesBaby+Size;
          lblSize.Caption := IntToStr (KB_found) + ' KB';
          ListBox.Items.Add (Format ('%5d  ', [KB]) + full_name);
    with FFListView do
    begin
      ListItem := Items.Add;
      ListItem.ImageIndex:=
        Get_FileTypeAndIconIndex(root + test_name,
                 FileTypePassed);
      ListItem.Caption := test_name;
      ListItem.SubItems.Add(root);
      ListItem.SubItems.Add(FileTypePassed);
      ListItem.SubItems.Add(Inttostr(Size));
      AttrS:=' ';
      If (Attr and faReadOnly > 0) then AttrS:=AttrS+'R';
      If (Attr and faArchive	> 0) then AttrS:=AttrS+'A';
      If (Attr and faSysFile  > 0) then AttrS:=AttrS+'S';
      If (Attr and faHidden   > 0) then AttrS:=AttrS+'H';
      ListItem.SubItems.Add(AttrS{Inttostr(Attr)});
      ListItem.SubItems.Add(DateTimeToStr(FileDateToDateTime(Time)));
    end;
          end;
        end;
        end;
    until FindNext (s) <> 0;
    FindClose (s);
If chSubFoldersToo.Checked then
begin
  test_name := root + '*.*';
  if FindFirst (test_name, faAnyFile, s) = 0 then
  repeat
    with s do
      if ((Attr and faDirectory) <> 0) and ((Name <> '.') and (Name <> '..'))
        then
        begin
        inc(DirSearched);
        SearchName(root + Name);
        end;
  until FindNext (s) <> 0;
  FindClose (s);
 end;
end;

procedure TSrchForm.SearchTypeExt (root: string);
var
AttrS,  test_name,Intest_name,full_name,FileTypePassed: string;
  s: TSearchRec;
  KB: integer;
  ListItem       : TListItem;
  wanted: integer;
  num_to_check: integer;
begin
  if stop_requested then Exit;
  root := LowerCase (root);
  HintsPanel.Caption := 'Searching ' + root + '...';
  if root [Length (root)] <> '\' then root := root + '\';
  num_to_check:= ExtMemo.Lines.Count;
  for wanted := 0 to num_to_check-1 do
    begin
    Intest_name := root + ExtMemo.Lines[wanted];
    Application.ProcessMessages;
    if FindFirst (Intest_name, faAnyFile, s) = 0 then
    repeat   Inc(FilesSearched);
      if stop_requested then Exit;
      with s do
        begin
        test_name := LowerCase (Name);
        if (Attr <> faDirectory) then
          begin   {skips problem of Directory NOT having dates}
          full_name := root + test_name;
          KB := (Size + 1023) div 1024;
          Inc (files_found);
          Inc (KB_found, KB);
          BytesBaby:=BytesBaby+Size;
          lblSize.Caption := IntToStr (KB_found) + ' KB';
          ListBox.Items.Add (Format ('%5d  ', [KB]) + full_name);
    with FFListView do
    begin
      ListItem := Items.Add;
      ListItem.ImageIndex:=
        Get_FileTypeAndIconIndex(root + test_name,
                 FileTypePassed);
      ListItem.Caption := test_name;
      ListItem.SubItems.Add(root);
      ListItem.SubItems.Add(FileTypePassed);
      ListItem.SubItems.Add(Inttostr(Size));
      AttrS:=' ';
      If (Attr and faReadOnly > 0) then AttrS:=AttrS+'R';
      If (Attr and faArchive	> 0) then AttrS:=AttrS+'A';
      If (Attr and faSysFile  > 0) then AttrS:=AttrS+'S';
      If (Attr and faHidden   > 0) then AttrS:=AttrS+'H';
      ListItem.SubItems.Add(AttrS{Inttostr(Attr)});
      ListItem.SubItems.Add(DateTimeToStr(FileDateToDateTime(Time)));
    end;
          end;
        end;
    until FindNext (s) <> 0;
    FindClose (s);
    end;
If chSubFoldersToo.Checked then
begin
  test_name := root + '*.*';
  if FindFirst (test_name, faAnyFile, s) = 0 then
  repeat
    with s do
      if ((Attr and faDirectory) <> 0) and ((Name <> '.') and (Name <> '..'))
        then
        begin
        inc(DirSearched);
        SearchTypeExt(root + Name);
        end;
  until FindNext (s) <> 0;
  FindClose (s);
end;
end;

procedure TSrchForm.SearchAttribute(root: string);
var
AttrS,  test_name,full_name,FileTypePassed: string;
  s: TSearchRec;
  KB: integer;
  ListItem       : TListItem;
  wanted: integer;
begin
  if stop_requested then Exit;
  If ReadOnlyCB.Checked then wanted := faReadOnly
  else    wanted := 0;
  If HiddenCB.Checked then wanted:=wanted+faHidden;
  If SystemCB.Checked then wanted:=wanted+faSysFile;
  If ArchiveCB.Checked then wanted:=wanted+faArchive;
  root := LowerCase (root);
  HintsPanel.Caption := 'Searching ' + root + '...';
  if root [Length (root)] <> '\' then root := root + '\';
    Application.ProcessMessages;
    if FindFirst (root+'*.*', faAnyFile, s) = 0 then
    repeat    Inc(FilesSearched);
      if stop_requested then Exit;
      with s do
        begin
        if (Attr <> faDirectory)and (Attr =wanted) then
          begin   {skips problem of Directory NOT having dates}
          test_name := LowerCase (Name);
          full_name := root + test_name;
          KB := (Size + 1023) div 1024;
          Inc (files_found);
          Inc (KB_found, KB);
          BytesBaby:=BytesBaby+Size;
          lblSize.Caption := IntToStr (KB_found) + ' KB';
          ListBox.Items.Add (Format ('%5d  ', [KB]) + full_name);
    with FFListView do
    begin
      ListItem := Items.Add;
      ListItem.ImageIndex:=
        Get_FileTypeAndIconIndex(root + test_name,
                 FileTypePassed);
      ListItem.Caption := test_name;
      ListItem.SubItems.Add(root);
      ListItem.SubItems.Add(FileTypePassed);
      ListItem.SubItems.Add(Inttostr(Size));
      AttrS:=' ';
      If (Attr and faReadOnly > 0) then AttrS:=AttrS+'R';
      If (Attr and faArchive	> 0) then AttrS:=AttrS+'A';
      If (Attr and faSysFile  > 0) then AttrS:=AttrS+'S';
      If (Attr and faHidden   > 0) then AttrS:=AttrS+'H';
      ListItem.SubItems.Add(AttrS{Inttostr(Attr)});
      ListItem.SubItems.Add(DateTimeToStr(FileDateToDateTime(Time)));
    end;
          end;
        end;
    until FindNext (s) <> 0;
    FindClose (s);
If chSubFoldersToo.Checked then
begin
  test_name := root + '*.*';
  if FindFirst (test_name, faAnyFile, s) = 0 then
  repeat
    with s do
      if ((Attr and faDirectory) <> 0) and ((Name <> '.') and (Name <> '..'))
        then
        begin
        inc(DirSearched);
        SearchAttribute(root + Name);
        end;
  until FindNext (s) <> 0;
  FindClose (s);
  end;
end;

procedure TSrchForm.SearchDate(root: string);
var
AttrS,  test_name,full_name,FileTypePassed: string;
  s: TSearchRec;
  KB: integer;
  ListItem       : TListItem;
  OlderThan,NewerThan: integer;
begin
  if stop_requested then Exit;
  NewerThan      := DateTimeToFileDate(dtpNewerThan.Date) ;
  OlderThan      := DateTimeToFileDate(dtpOlderThan.Date) ;
  root := LowerCase (root);
  HintsPanel.Caption := 'Searching ' + root + '...';
  if root [Length (root)] <> '\' then root := root + '\';
    Application.ProcessMessages;
    if FindFirst (root+'*.*', faAnyFile, s) = 0 then
    repeat Inc(FilesSearched);
      if stop_requested then Exit;
      with s do
        begin
        if (Attr <> faDirectory) then
          begin   {skips problem of Directory NOT having dates}
          If
(
                  ( ( OlderThan   = 0 ) and ( NewerThan   = 0 ) )
               or ( ( OlderThan   = 0 ) and ( NewerThan   > s.Time ))
               or ( ( NewerThan   = 0 ) and ( OlderThan   < s.Time ))
                   or (
                            (  ( NewerThan   > 0 ) and ( OlderThan   > 0) )
                       and  ( (OlderThan < s.Time ) and ( NewerThan > s.Time))

                       )
               )
               then
          begin
          test_name := LowerCase (Name);
          full_name := root + Name;
          KB := (Size + 1023) div 1024;
          Inc (files_found);
          Inc (KB_found, KB);
          BytesBaby:=BytesBaby+Size;
          lblSize.Caption := IntToStr (KB_found) + ' KB';
          ListBox.Items.Add (Format ('%5d  ', [KB]) + full_name);
    with FFListView do
    begin
      ListItem := Items.Add;
      ListItem.ImageIndex:=
        Get_FileTypeAndIconIndex(root + test_name,
                 FileTypePassed);
      ListItem.Caption := test_name;
      ListItem.SubItems.Add(root);
      ListItem.SubItems.Add(FileTypePassed);
      ListItem.SubItems.Add(Inttostr(Size));
      AttrS:=' ';
      If (Attr and faReadOnly > 0) then AttrS:=AttrS+'R';
      If (Attr and faArchive	> 0) then AttrS:=AttrS+'A';
      If (Attr and faSysFile  > 0) then AttrS:=AttrS+'S';
      If (Attr and faHidden   > 0) then AttrS:=AttrS+'H';
      ListItem.SubItems.Add(AttrS{Inttostr(Attr)});
      ListItem.SubItems.Add(DateTimeToStr(FileDateToDateTime(Time)));
    end;
          end;
          end;
        end;
    until FindNext (s) <> 0;
    FindClose (s);
If chSubFoldersToo.Checked then
begin
  test_name := root + '*.*';
  if FindFirst (test_name, faAnyFile, s) = 0 then
  repeat
    with s do
      if ((Attr and faDirectory) <> 0) and ((Name <> '.') and (Name <> '..'))
        then
        begin
        inc(DirSearched);
        SearchDate(root + Name);
        end;
  until FindNext (s) <> 0;
  FindClose (s);
  end;
end;

procedure TSrchForm.SearchSize(root: string);
var
AttrS,  test_name,full_name,FileTypePassed: string;
  s: TSearchRec;
  KB: integer;
  ListItem       : TListItem;
  SmallerThan,LargerThan: integer;
begin
  if stop_requested then Exit;
  LargerThan     :=(udLargerThan.Position + 1023) div 1024;
  SmallerThan    :=(udSmallerThan.Position + 1023) div 1024;

  root := LowerCase (root);
  HintsPanel.Caption := 'Searching ' + root + '...';
  if root [Length (root)] <> '\' then root := root + '\';
    Application.ProcessMessages;
    if FindFirst (root+'*.*', faAnyFile, s) = 0 then
    repeat  Inc(FilesSearched);
      if stop_requested then Exit;
      with s do
        begin

        if (Attr <> faDirectory)then
          begin   {skips problem of Directory NOT having dates}
          If
 (
                  ( ( SmallerThan   = 0 ) and ( LargerThan   = 0 ) )
               or ( ( SmallerThan   = 0 ) and ( LargerThan   < s.Size ))
               or ( ( LargerThan    = 0 ) and ( SmallerThan  > s.Size ))
                  or (
                            (  ( LargerThan   > 0 ) and ( SmallerThan   > 0) )
                       and ( (LargerThan < s.Size ) and ( SmallerThan > s.Size))

                           )
                )


          then
          begin
          test_name := LowerCase (Name);
          full_name := root + Name;
          KB := (Size + 1023) div 1024;
          Inc (files_found);
          Inc (KB_found, KB);
          BytesBaby:=BytesBaby+Size;
          lblSize.Caption := IntToStr (KB_found) + ' KB';
          ListBox.Items.Add (Format ('%5d  ', [KB]) + full_name);
    with FFListView do
    begin
      ListItem := Items.Add;
      ListItem.ImageIndex:=
        Get_FileTypeAndIconIndex(root + test_name,
                 FileTypePassed);
      ListItem.Caption := test_name;
      ListItem.SubItems.Add(root);
      ListItem.SubItems.Add(FileTypePassed);
      ListItem.SubItems.Add(Inttostr(Size));
      AttrS:=' ';
      If (Attr and faReadOnly > 0) then AttrS:=AttrS+'R';
      If (Attr and faArchive	> 0) then AttrS:=AttrS+'A';
      If (Attr and faSysFile  > 0) then AttrS:=AttrS+'S';
      If (Attr and faHidden   > 0) then AttrS:=AttrS+'H';
      ListItem.SubItems.Add(AttrS{Inttostr(Attr)});
      ListItem.SubItems.Add(DateTimeToStr(FileDateToDateTime(Time)));
    end;
          end;
          end;
        end;
    until FindNext (s) <> 0;
    FindClose (s);
If chSubFoldersToo.Checked then
begin
  test_name := root + '*.*';
  if FindFirst (test_name, faAnyFile, s) = 0 then
  repeat
    with s do
      if ((Attr and faDirectory) <> 0) and ((Name <> '.') and (Name <> '..'))
        then
        begin
        inc(DirSearched);
        SearchSize(root + Name);
        end;
  until FindNext (s) <> 0;
  FindClose (s);
  end;
end;

procedure TSrchForm.SearchAllCriteria(root: string);
var
AttrS,  SeachName,Intest_name,test_name,full_name,FileTypePassed: string;
  s: TSearchRec;
  ListItem       : TListItem;
  wanted,wanted2,
  num_to_check,  OlderThan,NewerThan,
  SmallerThan,LargerThan,  KB: integer;
begin
  if stop_requested then Exit;
  If (not(ReadOnlyCB.Checked
  and HiddenCB.Checked
  and SystemCB.Checked
  and ArchiveCB.Checked))
  then wanted := faAnyFile else
  If ReadOnlyCB.Checked then wanted := faReadOnly
  else    wanted := 0;
  If HiddenCB.Checked then wanted:=wanted+faHidden;
  If SystemCB.Checked then wanted:=wanted+faSysFile;
  If ArchiveCB.Checked then wanted:=wanted+faArchive;
  If chLargerThan.Checked then
     LargerThan     :=(udLargerThan.Position + 1023) div 1024
     else LargerThan:=0;
  If chSmallerThan.Checked then
     SmallerThan    :=(udSmallerThan.Position + 1023) div 1024
     else SmallerThan:=0;

  If chOlderThan.Checked then
     OlderThan      := DateTimeToFileDate(dtpOlderThan.Date)
     else OlderThan:=0;
  If chNewerThan.Checked then
     NewerThan      := DateTimeToFileDate(dtpNewerThan.Date)
     else NewerThan:=0;
   If chFileName.Checked then
      SeachName:=SrcFilenameEdit.Text
      else SeachName:= '*.*';
  root := LowerCase (root);
  HintsPanel.Caption := 'Searching ' + root + '...';
  if root [Length (root)] <> '\' then root := root + '\';
  If chExtension.Checked then
     num_to_check:= ExtMemo.Lines.Count
     else num_to_check:=0;
  for wanted2 := 0 to num_to_check-1 do
    begin
      If chExtension.Checked then
         Intest_name := root
         + Copy(SeachName,1,Length(SeachName)-(Length(SeachName)-pos('.',SeachName))  )
         + Copy(ExtMemo.Lines[wanted2],pos('.',ExtMemo.Lines[wanted2]),length(ExtMemo.Lines[wanted2])-1)
         else Intest_name := root +SeachName;

    Application.ProcessMessages;
    if FindFirst (Intest_name, faAnyFile, s) = 0 then
    repeat   Inc(FilesSearched);
      if stop_requested then Exit;
      with s do
        begin

        if (Attr <> faDirectory)and (Attr =wanted) then
          begin   {skips problem of Directory NOT having dates}
          If
 (
                  ( ( SmallerThan   = 0 ) and ( LargerThan   = 0 ) )
               or ( ( SmallerThan   = 0 ) and ( LargerThan   < s.Size ))
               or ( ( LargerThan    = 0 ) and ( SmallerThan  > s.Size ))
                  or (
                            (  ( LargerThan   > 0 ) and ( SmallerThan   > 0) )
                       and ( (LargerThan < s.Size ) and ( SmallerThan > s.Size))

                           )
                )
          and
(
                  ( ( OlderThan   = 0 ) and ( NewerThan   = 0 ) )
               or ( ( OlderThan   = 0 ) and ( NewerThan   > s.Time ))
               or ( ( NewerThan   = 0 ) and ( OlderThan   < s.Time ))
                   or (
                            (  ( NewerThan   > 0 ) and ( OlderThan   > 0) )
                       and  ( (OlderThan < s.Time ) and ( NewerThan > s.Time))

                       )
               )

          then
          Begin
          test_name := LowerCase (Name);
          full_name := root + Name;
          KB := (Size + 1023) div 1024;
          Inc (files_found);
          Inc (KB_found, KB);
          BytesBaby:=BytesBaby+Size;
          lblSize.Caption := IntToStr (KB_found) + ' KB';
          ListBox.Items.Add (Format ('%5d  ', [KB]) + full_name);
    with FFListView do
    begin
      ListItem := Items.Add;
      ListItem.ImageIndex:=
        Get_FileTypeAndIconIndex(root + test_name,
                 FileTypePassed);
      ListItem.Caption := test_name;
      ListItem.SubItems.Add(root);
      ListItem.SubItems.Add(FileTypePassed);
      ListItem.SubItems.Add(Inttostr(Size));
      AttrS:=' ';
      If (Attr and faReadOnly > 0) then AttrS:=AttrS+'R';
      If (Attr and faArchive	> 0) then AttrS:=AttrS+'A';
      If (Attr and faSysFile  > 0) then AttrS:=AttrS+'S';
      If (Attr and faHidden   > 0) then AttrS:=AttrS+'H';
      ListItem.SubItems.Add(AttrS{Inttostr(Attr)});
      ListItem.SubItems.Add(DateTimeToStr(FileDateToDateTime(Time)));
    end;
          end; end;
        end;
    until FindNext (s) <> 0;
    FindClose (s);
    end;
If chSubFoldersToo.Checked then
begin
  test_name := root + '*.*';
  if FindFirst (test_name, faAnyFile, s) = 0 then
  repeat
    with s do
      if ((Attr and faDirectory) <> 0) and ((Name <> '.') and (Name <> '..'))
        then
        begin
        inc(DirSearched);
        SearchAllCriteria(root + Name);
        end;
  until FindNext (s) <> 0;
  FindClose (s);
end;
end;


{
procedure TSrchForm.Panel1Resize(Sender: TObject);
  btnFind.Top := Panel1.Height - 16 - btnFind.Height;
  btnDelete.Top := btnFind.Top;
  btnSelectAll.Top := btnFind.Top;
  btnExit.Top := btnFind.Top;
  ListBox1.Height := btnFind.Top - 16 - ListBox1.Top;
  grpSeverity.Top := Panel1.Height - 8 - grpSeverity.Height;
  btnNormal.Top := grpSeverity.Top + 16;
  btnExtra.Top := grpSeverity.Top + 32;
  DriveComboBox1.Top := grpSeverity.Top - 16 - DriveComboBox1.Height;
  DirectoryListBox1.Height := DriveComboBox1.Top - 16 - DirectoryListBox1.Top;

procedure TSrchForm.Panel2Resize(Sender: TObject);
begin
  btnExit.Left := Panel2.Width - 16 - btnExit.Width;
  ListBox1.Width := Panel2.Width - 16 - ListBox1.Left;
}

procedure TSrchForm.FillMemoExt(Sender: TObject);
var
ExtFileName:String;
begin
Case TComponent(Sender).Tag of
0:ExtFileName:='Grafext.et0';
1:ExtFileName:='Grafext.et1';
2:ExtFileName:='Grafext.et2';
3:ExtFileName:='Grafext.et3';
4:ExtFileName:='Grafext.et4';
5:ExtFileName:='Grafext.et5';
6:ExtFileName:='Grafext.et6';
end;{case}
If FileExists(ProgramPath+ExtFileName) then
  ExtMemo.Lines.LoadFromFile(ProgramPath+ExtFileName)
  else
  begin
  TempMsgname:=ProgramPath+ExtFileName;
  ExtMemo.Lines.Add(      '*.*');
  DoMessages(39997);
  end;
end;
procedure TSrchForm.ClearExtBtnClick(Sender: TObject);
begin
  ExtMemo.Clear;
end;

procedure TSrchForm.btnHelpClick(Sender: TObject);
begin
  Application.HelpContext(4300);
end;

procedure TSrchForm.btnInfoClick(Sender: TObject);
begin
  PicAboutBox.Init(4);
  PicAboutBox.ShowModal;
end;

procedure TSrchForm.btnSelectAllClick(Sender: TObject);
var
  item: integer;
begin
  for item := 0 to ListBox.Items.Count-1 do
    ListBox.Selected[item] := True;
  btnDelete.Enabled := ListBox.SelCount <> 0;
  SetAttributeBtn.Enabled := ListBox.SelCount <> 0;
  SetDateBtn.Enabled := ListBox.SelCount <> 0;
  SaveList.Enabled := ListBox.SelCount <> 0;
  PrintList.Enabled := ListBox.SelCount <> 0;
  ViewList.Enabled := ListBox.SelCount <> 0;
end;

procedure TSrchForm.btnDeleteClick(Sender: TObject);
var
  item: integer;
  f: file;
  filename: string;
begin
  for item := ListBox.Items.Count-1 downto 0 do
    begin
    if ListBox.Selected [item] then
      begin
      filename := Trim (ListBox.Items.Strings [item]);
      // remove the file size part of the string
      while filename [1] <> ' ' do delete (filename, 1, 1);
      filename := Trim (filename);
      AssignFile (f, filename);
      {$I-}  Erase (f);  {$I+}
      if IOResult = 0
        then ListBox.Items.Delete (item)
        else
        begin
        TempMsgname :=filename;
        DoMessages(39988);
        end;
      end;
    end;

  if ListBox.Items.Count = 0 then
    begin
    Label1.Caption := '';
    btnDelete.Enabled := False;
    btnSelectAll.Enabled := False;
    end;
  lblSize.Caption := 'KBytes';
end;


procedure TSrchForm.SetAttributeBtnClick(Sender: TObject);
var
  item: integer;
  wanted: integer;
{  f: file; }
  filename: string;
begin
  If ListBox.Items.Count >0 then
  begin
  if stop_requested then Exit;
  If ReadOnlyCB.Checked then wanted := faReadOnly
  else    wanted := 0;
  If HiddenCB.Checked then wanted:=wanted+faHidden;
  If SystemCB.Checked then wanted:=wanted+faSysFile;
  If ArchiveCB.Checked then wanted:=wanted+faArchive;
    for item :=0 to ListBox.Items.Count-1 do
    begin
      if ListBox.Selected [item] then
      begin
        filename := Trim (ListBox.Items.Strings [item]);
        // remove the file size part of the string
        while filename [1] <> ' ' do delete (filename, 1, 1);
        filename := Trim (filename);
        If FileSetAttr(filename,wanted)<>0 then
        begin
          TempMsgname :=filename;
          DoMessages(39989);
          exit;
        end;
      end;
    end;
  end;
end;


procedure TSrchForm.SetDateBtnClick(Sender: TObject);
var
  FileHandle : Integer;
  NewDate,item: integer;
{  f: file; }
  filename: string;
begin
  If ListBox.Items.Count >0 then
  begin
    NewDate:=DateTimeToFileDate(dtpNewerThan.DateTime);
    for item :=0 to ListBox.Items.Count-1 do
    begin
      if ListBox.Selected [item] then
      begin
        filename := Trim (ListBox.Items.Strings [item]);
        // remove the file size part of the string
        while filename [1] <> ' ' do delete (filename, 1, 1);
        filename := Trim (filename);
        {Add to List}
        FileHandle := FileOpen(FileName, fmOpenWrite or fmShareDenyNone);
        if FileHandle > 0 then  {valid file handle}
        FileSetDate(FileHandle,NewDate)
        else
        begin
        FileClose(FileHandle);
        DoMessages(39998);
        {Open error: FileHandle = negative DOS error code}
        Exit;
        end ;
        FileClose(FileHandle);
      end;
    end;
  end;
end;


procedure TSrchForm.ViewListClick(Sender: TObject);
var
  item: integer;
  filename: string;
begin
  If ListBox.Items.Count >0 then
  begin
  ResultFileList.Clear;
    for item :=0 to ListBox.Items.Count-1 do
    begin
    if ListBox.Selected [item] then
      begin
      filename := Trim (ListBox.Items.Strings [item]);
      // remove the file size part of the string
      while filename [1] <> ' ' do delete (filename, 1, 1);
      filename := Trim (filename);
      {Add to List}
      ResultFileList.Add(filename);
      end;
    end;
    {Call the Browser}
   GBForm.BrowseList;
   GBForm.Show;
  end;
end;

procedure TSrchForm.ListListBtnClick(Sender: TObject);
var
  item: integer;
  filename: string;
begin
  If ListBox.Items.Count >0 then
  begin
  ResultFileList.Clear;
    for item :=0 to ListBox.Items.Count-1 do
    begin
    if ListBox.Selected [item] then
      begin
      filename := Trim (ListBox.Items.Strings [item]);
      // remove the file size part of the string
      while filename [1] <> ' ' do delete (filename, 1, 1);
      filename := Trim (filename);
      {Add to List}
      ResultFileList.Add(filename);
      end;
    end;
   GListForm.Show;
  end;
end;

procedure TSrchForm.DatabaseSelectedBtnClick(Sender: TObject);
var
  item: integer;
  filename: string;
begin
  If ListBox.Items.Count >0 then
  begin
    GCsvDbForm.ListBox2.Items.Clear;
    for item :=0 to ListBox.Items.Count-1 do
    begin
    if ListBox.Selected [item] then
      begin
        filename := Trim (ListBox.Items.Strings [item]);
      // remove the file size part of the string
      while filename [1] <> ' ' do delete (filename, 1, 1);
      filename := Trim (filename);
        GCsvDbForm.ListBox2.Items.Add(filename);
      end;
    end;
    GCsvDbForm.Show;
  end;
end;

procedure TSrchForm.PrintListClick(Sender: TObject);
var
  item: integer;
{  f: file; }
  filename: string;
   PrintText: TextFile;
begin
  If ListBox.Items.Count >0 then
  begin
    AssignPrn(PrintText);   {assigns PrintText to the printer}
    Rewrite(PrintText);     {creates and opens the output file}
    Printer.Canvas.Font := ListBox.Canvas.Font;  {assigns Font settings to the canvas}
    for item :=0 to ListBox.Items.Count-1 do
    begin
    if ListBox.Selected [item] then
      begin
      filename := Trim (ListBox.Items.Strings [item]);
      // remove the file size part of the string
      while filename [1] <> ' ' do delete (filename, 1, 1);
      filename := Trim (filename);
      {Add to List}
      Writeln(PrintText, filename);
      end;
    end;
    {Call the Browser}
    CloseFile(PrintText); {Closes the printer variable}
  end;
end;


procedure TSrchForm.SaveListClick(Sender: TObject);
var
  item: integer;
 F: TextFile;
  filename: string;
begin
  If ListBox.Items.Count >0 then
  begin
    AssignFile(F, DirectoryListBox.Directory
                +'/graflist.txt');
    Rewrite(F);
    for item :=0 to ListBox.Items.Count-1 do
    begin
    if ListBox.Selected [item] then
      begin
      filename := Trim (ListBox.Items.Strings [item]);
      // remove the file size part of the string
      while filename [1] <> ' ' do delete (filename, 1, 1);
      filename := Trim (filename);
      {Add to List}
      Writeln(F, filename);
      end;
    end;
    {Call the Browser}
    CloseFile(F);
  end;
end;


procedure TSrchForm.FFListViewClick(Sender: TObject);
var
 S : string;
begin
  if FFListView.Items.Count > 0
  then
    with FFListView do
    begin
      S := Items[Selected.Index].SubItems[0] + '\' + Items[Selected.Index].Caption;
    with PicViewBitmap do
    begin
      ViewFileName :=S;
      DoLoad(ViewFileName);
      FocusedListBox:= nil;
      Show;
    end;
      SaveResultListBtn.Enabled:= SelCount <> 0;
      PrintResultListBtn.Enabled:= SelCount <> 0;
    end;
end;

procedure TSrchForm.FFListViewDblClick(Sender: TObject);
var
 S : string;
begin
  if FFListView.Items.Count > 0
  then
    with FFListView do
    begin
      S := Items[Selected.Index].SubItems[0] + '\' + Items[Selected.Index].Caption;
      showmessage(s);
      ShellExecute( Handle,               { hWnd: HWND        }
                    'open',               { Operation: PChar  }
                    PChar(S),             { FileName: PChar   }
                    '',                   { Parameters: PChar }
                    '',                   { Directory: PChar  }
                    SW_SHOW );            { ShowCmd: Integer  }

    end;
end;

procedure TSrchForm.ResultSelectAllBtnClick(Sender: TObject);
var
  item: integer;
begin                {  Selected[item]}
  for item := 0 to FFListView.Items.Count-1 do
    FFListView.Items[item].Selected:= True;
  SaveResultListBtn.Enabled:= FFListView.SelCount <> 0;
  PrintResultListBtn.Enabled:= FFListView.SelCount <> 0;
end;
{  FilenameCB.Checked
  DirCB.Checked
  TypeCB.Checked
  BytesCB.Checked
  AttCB.Checked
  DateCB.Checked}
procedure TSrchForm.SaveResultListBtnClick(Sender: TObject);
var
  Alls, S : string;
  I: Integer;
  PrintText: TextFile;
begin
  if FFListView.Items.Count > 0  then
  begin
    AssignFile(PrintText, DirectoryListBox.Directory
                +'/graffind.txt');
    Rewrite(PrintText);
    with FFListView do
    begin
      For I := 0 to FFListView.Items.Count-1 do
      begin
        Alls:='';
        If PathFirstCB.Checked then
        begin
          If DirCB.Checked then
          begin
            S := Items[I].SubItems[0];
            If (Allon1lineCB.Checked) then Alls:=Alls+S+ '\' else Writeln(PrintText, S);
          end;
          If FilenameCB.Checked then
          begin
            S :=Items[I].Caption;
            If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
          end;
        end   else
        begin
          If FilenameCB.Checked then
          begin
            S :=Items[I].Caption;
            If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
          end;
          If DirCB.Checked then
          begin
            S :=Items[I].SubItems[0];
            If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
          end;
        end;
        If TypeCB.Checked then
        begin
          S :=Items[I].SubItems[1];
          If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
        end;
        If BytesCB.Checked then
        begin
          S :=Items[I].SubItems[2];
          If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
        end;
        If AttCB.Checked then
        begin
          S :=Items[I].SubItems[3];
          If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
        end;
        If DateCB.Checked then
        begin
          S :=Items[I].SubItems[4];
          If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
        end;
        If (Allon1lineCB.Checked) then Writeln(PrintText, Alls);
      end;
      CloseFile(PrintText); {Closes the printer variable}
    end;
  end;
end;

procedure TSrchForm.PrintResultListBtnClick(Sender: TObject);
var
  Alls, S : string;
  I: Integer;
  PrintText: TextFile;
begin
  if FFListView.Items.Count > 0  then
  begin
  {if PrintDialog1.Execute then}
  begin
    AssignPrn(PrintText);   {assigns PrintText to the printer}
    Rewrite(PrintText);     {creates and opens the output file}
    Printer.Canvas.Font := FFListView.Canvas.Font;  {assigns Font settings to the canvas}
    with FFListView do
    begin
      For I := 0 to FFListView.Items.Count-1 do
      begin
        Alls:='';
        If PathFirstCB.Checked then
        begin
          If DirCB.Checked then
          begin
            S := Items[I].SubItems[0];
            If (Allon1lineCB.Checked) then Alls:=Alls+S+ '\' else Writeln(PrintText, S);
          end;
          If FilenameCB.Checked then
          begin
            S :=Items[I].Caption;
            If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
          end;
        end   else
        begin
          If FilenameCB.Checked then
          begin
            S :=Items[I].Caption;
            If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
          end;
          If DirCB.Checked then
          begin
            S :=Items[I].SubItems[0];
            If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
          end;
        end;
        If TypeCB.Checked then
        begin
          S :=Items[I].SubItems[1];
          If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
        end;
        If BytesCB.Checked then
        begin
          S :=Items[I].SubItems[2];
          If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
        end;
        If AttCB.Checked then
        begin
          S :=Items[I].SubItems[3];
          If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
        end;
        If DateCB.Checked then
        begin
          S :=Items[I].SubItems[4];
          If (Allon1lineCB.Checked) then Alls:=Alls+S+ ',' else Writeln(PrintText, S);
        end;
        If (Allon1lineCB.Checked) then Writeln(PrintText, Alls);
      end;
      CloseFile(PrintText); {Closes the printer variable}
    end;
  end;
end;
end;




(******************************************************)
(******************************************************)

procedure TSrchForm.OpentoscanBtnClick(Sender: TObject);
begin
  if SelectDirectory(TransSearchDir, [sdAllowCreate, sdPerformCreate, sdPrompt],SELDIRHELP) then
{  chdir(ImagePath);}
  scan_tree;
end;

procedure TSrchForm.btnSearchClick(Sender: TObject);
begin
  TransSearchDir:=SFSDirectoryListBox.Directory;
  scan_tree;
  DoMessages(40001);  
end;
procedure TSrchForm.scan_tree;
var
SFSSubCBChecked:Boolean;
  sectors_per_cluster,
  bytes_per_sector,
  free_clusters,
  total_clusters: DWord;{integer;}
  cluster_bytes: integer;
  disk: array [0..3] of char;
  root: string;
begin
  if scanning then Exit;
  root :=TransSearchDir;{ GetCurrentDir;}
  if root [Length (root)] <> '\' then root := root + '\';
  StrPLcopy (disk, root, 3);
  if not show_allocated
  then cluster_bytes := 1
{function GetDiskFreeSpace(lpRootPathName: PChar;
  var lpSectorsPerCluster,
  lpBytesPerSector,
  lpNumberOfFreeClusters,
  lpTotalNumberOfClusters: DWORD): BOOL; stdcall;}

  else if GetDiskFreeSpace (disk, sectors_per_cluster, bytes_per_sector,
                            free_clusters, total_clusters)
       then cluster_bytes := bytes_per_sector * sectors_per_cluster
       else cluster_bytes := 1;
  try
    stop_requested := false;
    btnStop.Enabled := True;
    dir_list.SetDirectoryName (root);
    scanning := true;
    SFSSubCBChecked:=SFSSubCB.Checked;
    dir_list.scan (SFSSubCBChecked,stop_requested, cluster_bytes, set_status_text);
    display_list (dir_list);
    scanning := false;
    stop_requested := false;
    btnStop.Enabled := False;
  finally
  end;
end;


procedure TSrchForm.display_list (const list: TDirectoryList);
var
  str_list: TStringList;
  index: integer;
  size: integer;
{  total_size: integer;}
  s: string;
begin
  // prepare a string list with the sizes (numeric) and names
  // of the files and directories in this part of the tree
  str_list := TStringList.Create;
{  total_size := 0;}
  Series1.Clear;
  SFSListBox.Clear;
  SFSListBox.sorted:=False;
  for index := 0 to list.Count-1 do
    begin
    size := TDirectoryData (list.Objects[index]).GetBytes;
    Str (size, s);
    str_list.AddObject (s + '   ' + {LowerCase} (list.Strings[index]),
                        list.Objects[index]);
{    Inc (total_size, size);}
    Series1.Add( size, list.Strings[index]{'Pencil' }{, clRed} ) ;
    SFSListBox.Items.Add(list.Strings[index]+' = '+s );
    end;
    SFSListBox.sorted:=true;
    str_list.Free;
  // compute the status line
  with list do
    begin
    TotalLabel.Caption:=
      Format ('%s ... contains %1.n bytes in %1.n files and %1.n directories',
      [GetDirectoryName, GetTotalBytes + 0.0,
       GetTotalFiles + 0.0, GetTotalDirectories + 0.0]);
    Caption := 'ShowMan - ' + GetDirectoryName;
    btnUp.Enabled := GetParentDirectoryList <> nil;
    end;
end;


procedure TSrchForm.SFSListBoxDblClick(Sender: TObject);
var
  entry: TDirectoryData;
begin
  if SFSListBox.Items.Count > 0
  then
  begin
  entry := TDirectoryData (SFSListBox.Items.Objects [SFSListBox.ItemIndex]);
  handle_double_click (entry);
  end;
end;

procedure TSrchForm.handle_double_click (entry: TDirectoryData);
var
  lst: TDirectoryList;
begin
  if entry <> nil then
    with entry do
      begin
      lst := GetSubDirectoryList;
      if lst <> nil
      then
        display_list (lst)
      else
        begin
        lst := GetParentDirectoryList;
        if lst <> nil then
          display_list (lst)
        end;
      end;
end;

procedure TSrchForm.btnStopClick(Sender: TObject);
begin
  stop_requested := True;
end;

procedure TSrchForm.btnUpClick(Sender: TObject);
var
  lst: TDirectoryList;
begin
  if SFSListBox.Items.Count <> 0 then
    with TDirectoryData (SFSListBox.Items.Objects [0]) do
    begin
    lst := GetParentDirectoryList;
    if lst <> nil then
      display_list (lst)
    end;
end;

procedure TSrchForm.SFSHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(4300);
end;

procedure TSrchForm.Chart1ClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ShowMessage(' Clicked Series: ' +Series.Name+
             ' at point: '+ inttostr(valueindex)
             +' = '+
floattostr(Series1.PieValues[ valueindex ])
{Const AValue:Double; Const ALabel:String; AColor:TColor}
{             dir_list.Strings[valueindex]}
             );
end;

procedure TSrchForm.ShowSlackCBClick(Sender: TObject);
begin
    if show_allocated <> ShowSlackCB.Checked then
      begin
      // settings have changed, save the setting and re-scan
      show_allocated := ShowSlackCB.Checked;
      scan_tree;
      end;
end;

{procedure TSrchForm.InitShow;
Begin
  TransSearchDir:=SFSDirectoryListBox.Directory;
  scan_tree;
end;}

procedure set_status_text (const s: string);
begin
  SrchForm.HintsPanel.Caption := s;
end;

procedure TSrchForm.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TSrchForm.SFSInfoClick(Sender: TObject);
begin
{  PicAboutBox.Init(1);
  PicAboutBox.ShowModal; }
end;



procedure TSrchForm.PrintChartBtnClick(Sender: TObject);
begin
Print;
{PrintRect(Const R:TRect);
PrintOrientation(AOrientation:TPrinterOrientation);
PrintPortrait;
PrintLandscape;}
end;

procedure TSrchForm.ResultstoListClick(Sender: TObject);
var
 S,SS : string;
 I:Integer;
begin
  if SFSListBox.Items.Count > 0  then
  begin
    with SFSListBox do
    begin
      ResultFileList.Clear;
      For I := 0 to SFSListBox.Items.Count-1 do
      begin
        S :=SFSListBox.Items.Strings [I];
        SS:=Copy(S,1,(pos('=',S)-1));
        SS:=trim(SS);
        S := TransSearchDir + '\' + SS;
        {Add to Browser List}
        ResultFileList.Add(S);
      end;
   end;
   {Activate List with the List}
   GListForm.InitList;
   GListForm.Show;
  end;
end;

procedure TSrchForm.SFSViewClick(Sender: TObject);
var
 S,SS : string;
 I:Integer;
begin
  if SFSListBox.Items.Count > 0  then
  begin
    with SFSListBox do
    begin
      ResultFileList.Clear;
      For I := 0 to SFSListBox.Items.Count-1 do
      begin
        S :=SFSListBox.Items.Strings [I];
        SS:=Copy(S,1,(pos('=',S)-1));
        SS:=trim(SS);
        S := TransSearchDir + '\' + SS;
{        showmessage(s);}
        {Add to Browser List}
        ResultFileList.Add(S);
      end;
   end;
   {Activate Browser with the List}
   GBForm.BrowseList;
   GBForm.Show;
  end;
end;


procedure TSrchForm.SFSPrintClick(Sender: TObject);
var
 S,SS : string;
 I:Integer;
   PrintText: TextFile;
begin
  if SFSListBox.Items.Count > 0  then
  begin
    AssignPrn(PrintText);   {assigns PrintText to the printer}
    Rewrite(PrintText);     {creates and opens the output file}
    Printer.Canvas.Font := SFSListBox.Canvas.Font;  {assigns Font settings to the canvas}
    with SFSListBox do
    begin
      ResultFileList.Clear;
      For I := 0 to SFSListBox.Items.Count-1 do
      begin
        {redo Add to Browser List}
        S :=SFSListBox.Items[I];
        SS:=Copy(S,1,(pos('=',S)-1));
        SS:=trim(SS);
        S := TransSearchDir + '\' + SS;
        ResultFileList.Add(S);
        If DoSizeCB.Checked then
           SS:=SFSListBox.Items[I]
        else
        SS:=Copy(SFSListBox.Items[I],1,(pos('=',SFSListBox.Items[I])-1));
        If DoDirCB.Checked then
           S := TransSearchDir + '\' + SS
        else
        S := SS;
      Writeln(PrintText, S);
      end;
    CloseFile(PrintText); {Closes the printer variable}
   end;
  end;
end;


procedure TSrchForm.SFSSaveClick(Sender: TObject);
var
 S,SS : string;
 I:Integer;
 F: TextFile;
begin
  if SFSListBox.Items.Count > 0  then
  begin
    AssignFile(F, SFSDirectoryListBox.Directory
                +'/graflist.txt');
    Rewrite(F);
    with SFSListBox do
    begin
      ResultFileList.Clear;
      For I := 0 to SFSListBox.Items.Count-1 do
      begin
        {redo Add to Browser List}
        S :=SFSListBox.Items[I];
        SS:=Copy(S,1,(pos('=',S)-1));
        SS:=trim(SS);
        S := TransSearchDir + '\' + SS;
        ResultFileList.Add(S);
        If DoSizeCB.Checked then
           SS:=SFSListBox.Items[I]
        else
        begin
        S :=SFSListBox.Items[I];
        SS:=Copy(S,1,(pos('=',S)-1));
        SS:=trim(SS);
        end;
        If DoDirCB.Checked then
           S := TransSearchDir + '\' + SS
        else
        S := SS;
      Writeln(F, S);
      end;
       CloseFile(F);
   end;
  end;
end;

procedure TSrchForm.PageControl1Change(Sender: TObject);
begin
 if ((Sender as TPageControl).ActivePage = ShowFileSizeTS)
  then
  begin
    SFSSubCB.Checked:=False;
    TransSearchDir:=SFSDirectoryListBox.Directory;
    scan_tree;
  end;
end;


procedure TSrchForm.ActivateHogHunterBtnClick(Sender: TObject);
begin
szMainForm.Show;
end;

procedure TSrchForm.JumpLabelClick(Sender: TObject);
var
   s : string;
begin
   s := JumpLabel.Caption;
   ShellExecute(0, 'open', PChar(s), nil, nil, SW_SHOWNORMAL);
end;



end.
