{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gUUnclass;

interface
{ Place a USES declaration here }
uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  StdCtrls, ExtCtrls, Forms, ComCtrls, Buttons, Dialogs;
{ Place CONST, TYPE, and VAR declarations here }

{ Place PROCEDURE and FUNCTION declarations here }
procedure DoUnClassified(Seed, Choice, CR, SD, RA, MC: Integer);

implementation
{ Place a second USES declaration here }
uses gGlobal, gGrip, gClassifier;
{ Place private LABEL, CONST, TYPE, and VAR declarations here }

{ Place PROCEDURE and FUNCTION bodies here }

procedure DoUnClassified(Seed, Choice, CR, SD, RA, MC: Integer);
var
  UCArray2020: Array2020;
  RD, RG, RB: Double; RAll, InDistance: Extended;
  Temp: Longint;
  MinimumD: Array20E;
  j, i, Keeper, AdjustValue, Red, Green, Blue: Integer;
  Where, Line, Row, Col: DWord;
  sCR, sSD, sRA, sMC: string;
  SAll, SS, S, sSeed: string;

  UnClassified,
    US1, US2, US3, US4, US5, US6, US7, US8, US9, US10,
    US11, US12, US13, US14, US15, US16, US17, US18, US19, US20:
  ClassifiedRecord; {ClassStat;}
  Checker: T_Array;
begin
  sCR := ClassificationForm.CUCREdit.Text;
  sSD := ClassificationForm.CUSDEdit.Text;
  sRA := ClassificationForm.CURAEdit.Text;
  sMC := ClassificationForm.CUMCEdit.Text;
{$IFOPT R+}
{$DEFINE CKRANGE}
{$R-}
{$ENDIF}
  MakeImage;
  if ImageMade then begin
{Load Seed stats}
{Rmin,Rmax,Gmin,Gmax,Bmin,Bmax,CurrentClass:Byte;
Mean,Variance:Double;Count:Longint;}

    US1.Rmin := 0; US1.Rmax := RedStats[Seed, 1];
    US2.Rmin := (RedStats[Seed, 1] + 1); US2.Rmax := RedStats[Seed,
    2];
    US3.Rmin := (RedStats[Seed, 2] + 1); US3.Rmax := RedStats[Seed,
    3];
    US4.Rmin := (RedStats[Seed, 3] + 1); US4.Rmax := RedStats[Seed,
    4];
    US5.Rmin := (RedStats[Seed, 4] + 1); US5.Rmax := RedStats[Seed,
    5];
    US6.Rmin := (RedStats[Seed, 5] + 1); US6.Rmax := RedStats[Seed,
    6];
    US7.Rmin := (RedStats[Seed, 6] + 1); US7.Rmax := RedStats[Seed,
    7];
    US8.Rmin := (RedStats[Seed, 7] + 1); US8.Rmax := RedStats[Seed,
    8];
    US9.Rmin := (RedStats[Seed, 8] + 1); US9.Rmax := RedStats[Seed,
    9];
    US11.Gmin := 0; US11.Gmax := GreenStats[Seed, 1];
    US12.Gmin := (GreenStats[Seed, 1] + 1); US12.Gmax :=
    GreenStats[Seed, 2];
    US13.Gmin := (GreenStats[Seed, 2] + 1); US13.Gmax :=
    GreenStats[Seed, 3];
    US14.Gmin := (GreenStats[Seed, 3] + 1); US14.Gmax :=
    GreenStats[Seed, 4];
    US15.Gmin := (GreenStats[Seed, 4] + 1); US15.Gmax :=
    GreenStats[Seed, 5];
    US16.Gmin := (GreenStats[Seed, 5] + 1); US16.Gmax :=
    GreenStats[Seed, 6];
    US17.Gmin := (GreenStats[Seed, 6] + 1); US17.Gmax :=
    GreenStats[Seed, 7];
    US18.Gmin := (GreenStats[Seed, 7] + 1); US18.Gmax :=
    GreenStats[Seed, 8];
    US19.Gmin := (GreenStats[Seed, 8] + 1); US19.Gmax :=
    GreenStats[Seed, 9];
    US10.Bmin := 0; US10.Bmax := BlueStats[Seed, 1];
    US20.Bmin := (BlueStats[Seed, 1] + 1); US20.Bmax :=
    BlueStats[Seed, 2];


    US10.Count := 0; US20.Count := 0;
    US1.Count := 0; US7.Count := 0; US14.Count := 0;
    US2.Count := 0; US8.Count := 0; US15.Count := 0;
    US3.Count := 0; US9.Count := 0; US16.Count := 0;
    US4.Count := 0; US11.Count := 0; US17.Count := 0;
    US5.Count := 0; US12.Count := 0; US18.Count := 0;
    US6.Count := 0; US13.Count := 0; US19.Count := 0;
    for i := 1 to 20 do MinimumD[i] := 100000;
    Checker[10] := 0; Checker[20] := 0;
    Checker[1] := 0; Checker[2] := 0; Checker[3] := 0;
    Checker[4] := 0; Checker[5] := 0; Checker[6] := 0;
    Checker[7] := 0; Checker[8] := 0; Checker[9] := 0;
    Checker[11] := 0; Checker[12] := 0; Checker[13] := 0;
    Checker[14] := 0; Checker[15] := 0; Checker[16] := 0;
    Checker[17] := 0; Checker[18] := 0; Checker[19] := 0;


(*While ( (Checker[10] = 0) and (Checker[20] = 0) and
 (Checker[1] = 0) and (Checker[2] = 0) and (Checker[3] = 0) and
  (Checker[4] = 0) and (Checker[5] = 0) and (Checker[6] = 0) and
   (Checker[7] = 0) and (Checker[8] = 0) and (Checker[9] = 0) and

    (Checker[11] = 0) and (Checker[12] = 0) and (Checker[13] = 0) and
     (Checker[14] = 0) and (Checker[15] = 0) and (Checker[16] = 0) and
      (Checker[17] = 0) and (Checker[18] = 0) and (Checker[19] = 0))
    DO*) begin
   // Calculate the address of row in image data
      for Row := 0 to ImageHeight do begin
        Per_Done := Round(100 * (Row / (ImageHeight)));
        SetP_Done1(Per_Done);

        Line := (Row * BytesPerLine);
    // Calculate the address of desired pixel
        for Col := 0 to ImageWidth do begin
          Where := (Line + (Col * 3));
          lpPixelB := @PHugeByteArray(Image)^[Where];
          lpPixelG := @PHugeByteArray(Image)^[Where + 1];
          lpPixelR := @PHugeByteArray(Image)^[Where + 2];
          Blue := lpPixelB^;
          Green := lpPixelG^;
          Red := lpPixelR^;

{DO Classification}
{Rmin,Rmax,Gmin,Gmax,Bmin,Bmax,CurrentClass:Byte;
Mean,Variance:Double;Count:Longint;}
          if Checker[10] = 0 then begin
            if ((Blue > US10.Bmin) and (Blue <= US10.Bmax)) then
            begin
              US10.Count := 1;
              US10.RValues := (Red);
              US10.GValues := (Green);
              US10.BValues := (Blue);
              Temp := ((US10.RValues) - CR); if Temp < 0 then
                Temp := 0; US10.Rmin := Temp;
              Temp := ((US10.RValues) + CR); if Temp > 255 then
                Temp := 255; US10.Rmax := Temp;
              Temp := ((US10.GValues) - CR); if Temp < 0 then
                Temp := 0; US10.Gmin := Temp;
              Temp := ((US10.GValues) + CR); if Temp > 255 then
                Temp := 255; US10.Gmax := Temp;
              Temp := ((US10.BValues) - CR); if Temp < 0 then
                Temp := 0; US10.Bmin := Temp;
              Temp := ((US10.BValues) + CR); if Temp > 255 then
                Temp := 255; US10.Bmax := Temp;
              Checker[10] := 1;
            end; end else
            if Checker[20] = 0 then begin
              if ((Blue > US20.Bmin) and (Blue <= US20.Bmax)) then
              begin
                US20.Count := 1;
                US20.RValues := (Red);
                US20.GValues := (Green);
                US20.BValues := (Blue);
                Temp := ((US20.RValues) - CR); if Temp < 0 then
                  Temp := 0; US20.Rmin := Temp;
                Temp := ((US20.RValues) + CR); if Temp > 255 then
                  Temp := 255; US20.Rmax := Temp;
                Temp := ((US20.GValues) - CR); if Temp < 0 then
                  Temp := 0; US20.Gmin := Temp;
                Temp := ((US20.GValues) + CR); if Temp > 255 then
                  Temp := 255; US20.Gmax := Temp;
                Temp := ((US20.BValues) - CR); if Temp < 0 then
                  Temp := 0; US20.Bmin := Temp;
                Temp := ((US20.BValues) + CR); if Temp > 255 then
                  Temp := 255; US20.Bmax := Temp;
                Checker[20] := 1;
              end; end else
              if Checker[1] = 0 then begin
                if ((Red > US1.Rmin) and (Red <= US1.Rmax)) then
                begin
                  US1.Count := 1;
                  US1.RValues := (Red);
                  US1.GValues := (Green);
                  US1.BValues := (Blue);
                  Temp := ((US1.RValues) - CR); if Temp < 0 then
                    Temp := 0; US1.Rmin := Temp;
                  Temp := ((US1.RValues) + CR); if Temp > 255 then
                    Temp := 255; US1.Rmax := Temp;
                  Temp := ((US1.GValues) - CR); if Temp < 0 then
                    Temp := 0; US1.Gmin := Temp;
                  Temp := ((US1.GValues) + CR); if Temp > 255 then
                    Temp := 255; US1.Gmax := Temp;
                  Temp := ((US1.BValues) - CR); if Temp < 0 then
                    Temp := 0; US1.Bmin := Temp;
                  Temp := ((US1.BValues) + CR); if Temp > 255 then
                    Temp := 255; US1.Bmax := Temp;
                  Checker[1] := 1;
                end; end else
                if Checker[2] = 0 then begin
                  if ((Red > US2.Rmin) and (Red <= US2.Rmax)) then
                  begin
                    US2.Count := 1;
                    US2.RValues := (Red);
                    US2.GValues := (Green);
                    US2.BValues := (Blue);
                    Temp := ((US2.RValues) - CR); if Temp < 0 then
                      Temp := 0; US2.Rmin := Temp;
                    Temp := ((US2.RValues) + CR); if Temp > 255 then
                      Temp := 255; US2.Rmax := Temp;
                    Temp := ((US2.GValues) - CR); if Temp < 0 then
                      Temp := 0; US2.Gmin := Temp;
                    Temp := ((US2.GValues) + CR); if Temp > 255 then
                      Temp := 255; US2.Gmax := Temp;
                    Temp := ((US2.BValues) - CR); if Temp < 0 then
                      Temp := 0; US2.Bmin := Temp;
                    Temp := ((US2.BValues) + CR); if Temp > 255 then
                      Temp := 255; US2.Bmax := Temp;
                    Checker[2] := 1;
                  end; end else
                  if Checker[3] = 0 then begin
                    if ((Red > US3.Rmin) and (Red <= US3.Rmax)) then
                    begin
                      US3.Count := 1;
                      US3.RValues := (Red);
                      US3.GValues := (Green);
                      US3.BValues := (Blue);
                      Temp := ((US3.RValues) - CR); if Temp < 0 then
                        Temp := 0; US3.Rmin := Temp;
                      Temp := ((US3.RValues) + CR); if Temp > 255
                        then
                        Temp := 255; US3.Rmax := Temp;
                      Temp := ((US3.GValues) - CR); if Temp < 0 then
                        Temp := 0; US3.Gmin := Temp;
                      Temp := ((US3.GValues) + CR); if Temp > 255
                        then
                        Temp := 255; US3.Gmax := Temp;
                      Temp := ((US3.BValues) - CR); if Temp < 0 then
                        Temp := 0; US3.Bmin := Temp;
                      Temp := ((US3.BValues) + CR); if Temp > 255
                        then
                        Temp := 255; US3.Bmax := Temp;
                      Checker[3] := 1;
                    end; end else
                    if Checker[4] = 0 then begin
                      if ((Red > US4.Rmin) and (Red <= US4.Rmax))
                        then
                      begin
                        US4.Count := 1;
                        US4.RValues := (Red);
                        US4.GValues := (Green);
                        US4.BValues := (Blue);
                        Temp := ((US4.RValues) - CR); if Temp < 0
                          then
                          Temp := 0; US4.Rmin := Temp;
                        Temp := ((US4.RValues) + CR); if Temp > 255
                        then Temp := 255; US4.Rmax := Temp;
                        Temp := ((US4.GValues) - CR); if Temp < 0
                          then
                          Temp := 0; US4.Gmin := Temp;
                        Temp := ((US4.GValues) + CR); if Temp > 255
                        then Temp := 255; US4.Gmax := Temp;
                        Temp := ((US4.BValues) - CR); if Temp < 0
                          then
                          Temp := 0; US4.Bmin := Temp;
                        Temp := ((US4.BValues) + CR); if Temp > 255
                        then Temp := 255; US4.Bmax := Temp;
                        Checker[4] := 1;
                      end; end else
                      if Checker[5] = 0 then begin
                        if ((Red > US5.Rmin) and (Red <= US5.Rmax))
                          then
                        begin
                          US5.Count := 1;
                          US5.RValues := (Red);
                          US5.GValues := (Green);
                          US5.BValues := (Blue);
                          Temp := ((US5.RValues) - CR); if Temp < 0
                          then Temp := 0; US5.Rmin := Temp;
                          Temp := ((US5.RValues) + CR); if Temp > 255
                          then Temp := 255; US5.Rmax := Temp;
                          Temp := ((US5.GValues) - CR); if Temp < 0
                          then Temp := 0; US5.Gmin := Temp;
                          Temp := ((US5.GValues) + CR); if Temp > 255
                          then Temp := 255; US5.Gmax := Temp;
                          Temp := ((US5.BValues) - CR); if Temp < 0
                          then Temp := 0; US5.Bmin := Temp;
                          Temp := ((US5.BValues) + CR); if Temp > 255
                          then Temp := 255; US5.Bmax := Temp;
                          Checker[5] := 1;
                        end; end else
                        if Checker[6] = 0 then begin
                          if ((Red > US6.Rmin) and (Red <= US6.Rmax))
                            then
                          begin
                            US6.Count := 1;
                            US6.RValues := (Red);
                            US6.GValues := (Green);
                            US6.BValues := (Blue);
                            Temp := ((US6.RValues) - CR); if Temp < 0
                            then Temp := 0; US6.Rmin := Temp;
                            Temp := ((US6.RValues) + CR); if Temp >
                            255 then Temp := 255; US6.Rmax := Temp;
                            Temp := ((US6.GValues) - CR); if Temp < 0
                            then Temp := 0; US6.Gmin := Temp;
                            Temp := ((US6.GValues) + CR); if Temp >
                            255 then Temp := 255; US6.Gmax := Temp;
                            Temp := ((US6.BValues) - CR); if Temp < 0
                            then Temp := 0; US6.Bmin := Temp;
                            Temp := ((US6.BValues) + CR); if Temp >
                            255 then Temp := 255; US6.Bmax := Temp;
                            Checker[6] := 1;
                          end; end else
                          if Checker[7] = 0 then begin
                            if ((Red > US7.Rmin) and (Red <=
                              US7.Rmax)) then
                            begin
                              US7.Count := 1;
                              US7.RValues := (Red);
                              Us7.GValues := (Green);
                              US7.BValues := (Blue);
                              Temp := ((US7.RValues) - CR); if Temp <
                              0 then Temp := 0; US7.Rmin := Temp;
                              Temp := ((US7.RValues) + CR); if Temp >
                              255 then Temp := 255; US7.Rmax := Temp;
                              Temp := ((US7.GValues) - CR); if Temp <
                              0 then Temp := 0; US7.Gmin := Temp;
                              Temp := ((US7.GValues) + CR); if Temp >
                              255 then Temp := 255; US7.Gmax := Temp;
                              Temp := ((US7.BValues) - CR); if Temp <
                              0 then Temp := 0; US7.Bmin := Temp;
                              Temp := ((US7.BValues) + CR); if Temp >
                              255 then Temp := 255; US7.Bmax := Temp;
                              Checker[7] := 1;
                            end; end else
                            if Checker[8] = 0 then begin
                              if ((Red > US8.Rmin) and (Red <=
                                US8.Rmax)) then
                              begin
                                US8.Count := 1;
                                US8.RValues := (Red);
                                US8.GValues := (Green);
                                US8.BValues := (Blue);
                                Temp := ((US8.RValues) - CR); if Temp
                                < 0 then Temp := 0; US8.Rmin := Temp;
                                Temp := ((US8.RValues) + CR); if Temp
                                > 255 then
                                  Temp := 255; US8.Rmax := Temp;
                                Temp := ((US8.GValues) - CR); if Temp
                                < 0 then Temp := 0; US8.Gmin := Temp;
                                Temp := ((US8.GValues) + CR); if Temp
                                > 255 then
                                  Temp := 255; US8.Gmax := Temp;
                                Temp := ((US8.BValues) - CR); if Temp
                                < 0 then Temp := 0; US8.Bmin := Temp;
                                Temp := ((US8.BValues) + CR); if Temp
                                > 255 then
                                  Temp := 255; US8.Bmax := Temp;
                                Checker[8] := 1;
                              end; end else
                              if Checker[9] = 0 then begin
                                if ((Red > US9.Rmin) and (Red <=
                                  US9.Rmax)) then
                                begin
                                  US9.Count := 1;
                                  US9.RValues := (Red);
                                  US9.GValues := (Green);
                                  US9.BValues := (Blue);
                                  Temp := ((US9.RValues) - CR); if
                                  Temp < 0 then
                                    Temp := 0; US9.Rmin := Temp;
                                  Temp := ((US9.RValues) + CR); if
                                  Temp > 255 then
                                    Temp := 255; US9.Rmax := Temp;
                                  Temp := ((US9.GValues) - CR); if
                                  Temp < 0 then
                                    Temp := 0; US9.Gmin := Temp;
                                  Temp := ((US9.GValues) + CR); if
                                  Temp > 255 then
                                    Temp := 255; US9.Gmax := Temp;
                                  Temp := ((US9.BValues) - CR); if
                                  Temp < 0 then
                                    Temp := 0; US9.Bmin := Temp;
                                  Temp := ((US9.BValues) + CR); if
                                  Temp > 255 then
                                    Temp := 255; US9.Bmax := Temp;
                                  Checker[9] := 1;
                                end; end else

                                if Checker[11] = 0 then begin
                                  if ((Green > US11.Gmin) and (Green
                                    <= US11.Gmax)) then
                                  begin
                                    US11.Count := 1;
                                    US11.RValues := (Red);
                                    US11.GValues := (Green);
                                    US11.BValues := (Blue);
                                    Temp := ((US11.RValues) - CR); if
                                    Temp < 0 then
                                      Temp := 0; US11.Rmin := Temp;
                                    Temp := ((US11.RValues) + CR); if
                                    Temp > 255 then
                                      Temp := 255; US11.Rmax := Temp;
                                    Temp := ((US11.GValues) - CR); if
                                    Temp < 0 then
                                      Temp := 0; US11.Gmin := Temp;
                                    Temp := ((US11.GValues) + CR); if
                                    Temp > 255 then
                                      Temp := 255; US11.Gmax := Temp;
                                    Temp := ((US11.BValues) - CR); if
                                    Temp < 0 then
                                      Temp := 0; US11.Bmin := Temp;
                                    Temp := ((US11.BValues) + CR); if
                                    Temp > 255 then
                                      Temp := 255; US11.Bmax := Temp;
                                    Checker[11] := 1;
                                  end; end else
                                  if Checker[12] = 0 then begin
                                    if ((Green > US12.Gmin) and (Green
                                      <= US12.Gmax)) then
                                    begin
                                      US12.Count := 1;
                                      US12.RValues := (Red);
                                      US12.GValues := (Green);
                                      US12.BValues := (Blue);
                                      Temp := ((US12.RValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US12.Rmin := Temp;
                                      Temp := ((US12.RValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US12.Rmax :=
                                          Temp;
                                      Temp := ((US12.GValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US12.Gmin := Temp;
                                      Temp := ((US12.GValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US12.Gmax :=
                                          Temp;
                                      Temp := ((US12.BValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US12.Bmin := Temp;
                                      Temp := ((US12.BValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US12.Bmax :=
                                          Temp;
                                      Checker[12] := 1;
                                    end; end else if Checker[13] = 0
                                    then begin
                                    if ((Green > US13.Gmin) and (Green
                                      <= US13.Gmax)) then
                                    begin
                                      US13.Count := 1;
                                      US13.RValues := (Red);
                                      US13.GValues := (Green);
                                      US13.BValues := (Blue);
                                      Temp := ((US13.RValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US13.Rmin := Temp;
                                      Temp := ((US13.RValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US13.Rmax :=
                                          Temp;
                                      Temp := ((US13.GValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US13.Gmin := Temp;
                                      Temp := ((US13.GValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US13.Gmax :=
                                          Temp;
                                      Temp := ((US13.BValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US13.Bmin := Temp;
                                      Temp := ((US13.BValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US13.Bmax :=
                                          Temp;
                                      Checker[13] := 1;
                                    end; end else if Checker[14] = 0
                                    then begin
                                    if ((Green > US14.Gmin) and (Green
                                      <= US14.Gmax)) then
                                    begin
                                      US14.Count := 1;
                                      US14.RValues := (Red);
                                      US14.GValues := (Green);
                                      US14.BValues := (Blue);
                                      Temp := ((US14.RValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US14.Rmin := Temp;
                                      Temp := ((US14.RValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US14.Rmax :=
                                          Temp;
                                      Temp := ((US14.GValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US14.Gmin := Temp;
                                      Temp := ((US14.GValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US14.Gmax :=
                                          Temp;
                                      Temp := ((US14.BValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US14.Bmin := Temp;
                                      Temp := ((US14.BValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US14.Bmax :=
                                          Temp;
                                      Checker[14] := 1;
                                    end; end else if Checker[15] = 0
                                    then begin
                                    if ((Green > US15.Gmin) and (Green
                                      <= US15.Gmax)) then
                                    begin
                                      US15.Count := 1;
                                      US15.RValues := (Red);
                                      US15.GValues := (Green);
                                      US15.BValues := (Blue);
                                      Temp := ((US15.RValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US15.Rmin := Temp;
                                      Temp := ((US15.RValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US15.Rmax :=
                                          Temp;
                                      Temp := ((US15.GValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US15.Gmin := Temp;
                                      Temp := ((US15.GValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US15.Gmax :=
                                          Temp;
                                      Temp := ((US15.BValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US15.Bmin := Temp;
                                      Temp := ((US15.BValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US15.Bmax :=
                                          Temp;
                                      Checker[15] := 1;
                                    end; end else if Checker[16] = 0
                                    then begin
                                    if ((Green > US16.Gmin) and (Green
                                      <= US16.Gmax)) then
                                    begin
                                      US16.Count := 1;
                                      US16.RValues := (Red);
                                      US16.GValues := (Green);
                                      US16.BValues := (Blue);
                                      Temp := ((US16.RValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US16.Rmin := Temp;
                                      Temp := ((US16.RValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US16.Rmax :=
                                          Temp;
                                      Temp := ((US16.GValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US16.Gmin := Temp;
                                      Temp := ((US16.GValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US16.Gmax :=
                                          Temp;
                                      Temp := ((US16.BValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US16.Bmin := Temp;
                                      Temp := ((US16.BValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US16.Bmax :=
                                          Temp;
                                      Checker[16] := 1;
                                    end; end else if Checker[17] = 0
                                    then begin
                                    if ((Green > US17.Gmin) and (Green
                                      <= US17.Gmax)) then
                                    begin
                                      US17.Count := 1;
                                      US17.RValues := (Red);
                                      US17.GValues := (Green);
                                      US17.BValues := (Blue);
                                      Temp := ((US17.RValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US17.Rmin := Temp;
                                      Temp := ((US17.RValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US17.Rmax :=
                                          Temp;
                                      Temp := ((US17.GValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US17.Gmin := Temp;
                                      Temp := ((US17.GValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US17.Gmax :=
                                          Temp;
                                      Temp := ((US17.BValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US17.Bmin := Temp;
                                      Temp := ((US17.BValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US17.Bmax :=
                                          Temp;
                                      Checker[17] := 1;
                                    end; end else if Checker[18] = 0
                                    then begin
                                    if ((Green > US18.Gmin) and (Green
                                      <= US18.Gmax)) then
                                    begin
                                      US18.Count := 1;
                                      US18.RValues := (Red);
                                      US18.GValues := (Green);
                                      US18.BValues := (Blue);
                                      Temp := ((US18.RValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US18.Rmin := Temp;
                                      Temp := ((US18.RValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US18.Rmax :=
                                          Temp;
                                      Temp := ((US18.GValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US18.Gmin := Temp;
                                      Temp := ((US18.GValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US18.Gmax :=
                                          Temp;
                                      Temp := ((US18.BValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US18.Bmin := Temp;
                                      Temp := ((US18.BValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US18.Bmax :=
                                          Temp;
                                      Checker[18] := 1;
                                    end; end else if Checker[19] = 0
                                    then begin
                                    if ((Green > US19.Gmin) and (Green
                                      <= US19.Gmax)) then
                                    begin
                                      US19.Count := 1;
                                      US19.RValues := (Red);
                                      US19.GValues := (Green);
                                      US19.BValues := (Blue);
                                      Temp := ((US19.RValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US19.Rmin := Temp;
                                      Temp := ((US19.RValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US19.Rmax :=
                                          Temp;
                                      Temp := ((US19.GValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US19.Gmin := Temp;
                                      Temp := ((US19.GValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US19.Gmax :=
                                          Temp;
                                      Temp := ((US19.BValues) - CR);
                                      if Temp < 0 then
                                        Temp := 0; US19.Bmin := Temp;
                                      Temp := ((US19.BValues) + CR);
                                      if Temp > 255 then
                                        Temp := 255; US19.Bmax :=
                                          Temp;
                                      Checker[19] := 1;
                                    end;
                                  end;
        end; end; end; {of DO BEGIN WHILE  SEED LOOP}


{THIS CHANGE THE MIN MAX}

    UnClassified.Count := 0;
    UnClassified.RValues := 0;
    UnClassified.GValues := 0;
    UnClassified.BValues := 0;
{Classification Loop}
   // Calculate the address of row in image data
    for Row := 0 to ImageHeight do begin
      Per_Done := Round(100 * (Row / (ImageHeight)));
      SetP_Done1(Per_Done);

      Line := (Row * BytesPerLine);
    // Calculate the address of desired pixel
      for Col := 0 to ImageWidth do begin
        Where := (Line + (Col * 3));
        lpPixelB := @PHugeByteArray(Image)^[Where];
        lpPixelG := @PHugeByteArray(Image)^[Where + 1];
        lpPixelR := @PHugeByteArray(Image)^[Where + 2];
        Blue := lpPixelB^;
        Green := lpPixelG^;
        Red := lpPixelR^;
        if ((US1.Count > 0) and (Red >= US1.Rmin) and (Red <=
          US1.Rmax) and
          (Green >= US1.Gmin) and (Green <= US1.Gmax) and
          (Blue >= US1.Bmin) and (Blue <= US1.Bmax)) then
        begin
          inc(US1.Count);
          US1.RValues := (US1.RValues + Red);
          US1.GValues := (US1.GValues + Green);
          US1.BValues := (US1.BValues + Blue);
          Temp := ((US1.RValues div US1.Count) - CR); if Temp < 0
            then
            Temp := 0; US1.Rmin := Temp;
          Temp := ((US1.RValues div US1.Count) + CR); if Temp > 255
          then Temp := 255; US1.Rmax := Temp;
          Temp := ((US1.GValues div US1.Count) - CR); if Temp < 0
            then
            Temp := 0; US1.Gmin := Temp;
          Temp := ((US1.GValues div US1.Count) + CR); if Temp > 255
          then Temp := 255; US1.Gmax := Temp;
          Temp := ((US1.BValues div US1.Count) - CR); if Temp < 0
            then
            Temp := 0; US1.Bmin := Temp;
          Temp := ((US1.BValues div US1.Count) + CR); if Temp > 255
          then Temp := 255; US1.Bmax := Temp;
          Blue := GetBValue(MMW); Red := GetRValue(MMW);
          Green := GetGValue(MMW);
          lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ := Red;
        end else
          if ((US2.Count > 0) and (Red >= US2.Rmin) and (Red <=
            US2.Rmax) and
            (Green >= US2.Gmin) and (Green <= US2.Gmax) and
            (Blue >= US2.Bmin) and (Blue <= US2.Bmax)) then
          begin
            inc(US2.Count);
            US2.RValues := (US2.RValues + Red);
            US2.GValues := (US2.GValues + Green);
            US2.BValues := (US2.BValues + Blue);
            Temp := ((US2.RValues div US2.Count) - CR); if Temp < 0
            then Temp := 0; US2.Rmin := Temp;
            Temp := ((US2.RValues div US2.Count) + CR); if Temp > 255
            then Temp := 255; US2.Rmax := Temp;
            Temp := ((US2.GValues div US2.Count) - CR); if Temp < 0
            then Temp := 0; US2.Gmin := Temp;
            Temp := ((US2.GValues div US2.Count) + CR); if Temp > 255
            then Temp := 255; US2.Gmax := Temp;
            Temp := ((US2.BValues div US2.Count) - CR); if Temp < 0
            then Temp := 0; US2.Bmin := Temp;
            Temp := ((US2.BValues div US2.Count) + CR); if Temp > 255
            then Temp := 255; US2.Bmax := Temp;
            Blue := GetBValue(MMC); Red := GetRValue(MMC);
            Green := GetGValue(MMC);
            lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ := Red;
          end else
            if ((US3.Count > 0) and (Red >= US3.Rmin) and (Red <=
              US3.Rmax) and
              (Green >= US3.Gmin) and (Green <= US3.Gmax) and
              (Blue >= US3.Bmin) and (Blue <= US3.Bmax)) then
            begin
              inc(US3.Count);
              US3.RValues := (US3.RValues + Red);
              US3.GValues := (US3.GValues + Green);
              US3.BValues := (US3.BValues + Blue);
              Temp := ((US3.RValues div US3.Count) - CR); if Temp < 0
              then Temp := 0; US3.Rmin := Temp;
              Temp := ((US3.RValues div US3.Count) + CR); if Temp >
              255 then Temp := 255; US3.Rmax := Temp;
              Temp := ((US3.GValues div US3.Count) - CR); if Temp < 0
              then Temp := 0; US3.Gmin := Temp;
              Temp := ((US3.GValues div US3.Count) + CR); if Temp >
              255 then Temp := 255; US3.Gmax := Temp;
              Temp := ((US3.BValues div US3.Count) - CR); if Temp < 0
              then Temp := 0; US3.Bmin := Temp;
              Temp := ((US3.BValues div US3.Count) + CR); if Temp >
              255 then Temp := 255; US3.Bmax := Temp;
              Blue := GetBValue(MMF); Red := GetRValue(MMF);
              Green := GetGValue(MMF);
              lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
              Red;
            end else
              if ((US4.Count > 0) and (Red >= US4.Rmin) and (Red <=
                US4.Rmax) and
                (Green >= US4.Gmin) and (Green <= US4.Gmax) and
                (Blue >= US4.Bmin) and (Blue <= US4.Bmax)) then
              begin
                inc(US4.Count);
                US4.RValues := (US4.RValues + Red);
                US4.GValues := (US4.GValues + Green);
                US4.BValues := (US4.BValues + Blue);
                Temp := ((US4.RValues div US4.Count) - CR); if Temp <
                0 then Temp := 0; US4.Rmin := Temp;
                Temp := ((US4.RValues div US4.Count) + CR); if Temp >
                255 then Temp := 255; US4.Rmax := Temp;
                Temp := ((US4.GValues div US4.Count) - CR); if Temp <
                0 then Temp := 0; US4.Gmin := Temp;
                Temp := ((US4.GValues div US4.Count) + CR); if Temp >
                255 then Temp := 255; US4.Gmax := Temp;
                Temp := ((US4.BValues div US4.Count) - CR); if Temp <
                0 then Temp := 0; US4.Bmin := Temp;
                Temp := ((US4.BValues div US4.Count) + CR); if Temp >
                255 then Temp := 255; US4.Bmax := Temp;
                Blue := GetBValue(MMA); Red := GetRValue(MMA);
                Green := GetGValue(MMA);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red;
              end else
                if ((US5.Count > 0) and (Red >= US5.Rmin) and (Red <=
                  US5.Rmax) and
                  (Green >= US5.Gmin) and (Green <= US5.Gmax) and
                  (Blue >= US5.Bmin) and (Blue <= US5.Bmax)) then
                begin
                  inc(US5.Count);
                  US5.RValues := (US5.RValues + Red);
                  US5.GValues := (US5.GValues + Green);
                  US5.BValues := (US5.BValues + Blue);
                  Temp := ((US5.RValues div US5.Count) - CR); if Temp
                  < 0 then Temp := 0; US5.Rmin := Temp;
                  Temp := ((US5.RValues div US5.Count) + CR); if Temp
                  > 255 then Temp := 255; US5.Rmax := Temp;
                  Temp := ((US5.GValues div US5.Count) - CR); if Temp
                  < 0 then Temp := 0; US5.Gmin := Temp;
                  Temp := ((US5.GValues div US5.Count) + CR); if Temp
                  > 255 then Temp := 255; US5.Gmax := Temp;
                  Temp := ((US5.BValues div US5.Count) - CR); if Temp
                  < 0 then Temp := 0; US5.Bmin := Temp;
                  Temp := ((US5.BValues div US5.Count) + CR); if Temp
                  > 255 then Temp := 255; US5.Bmax := Temp;
                  Blue := GetBValue(MMR); Red := GetRValue(MMR);
                  Green := GetGValue(MMR);
                  lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                  Red;
                end else
                  if ((US6.Count > 0) and (Red >= US6.Rmin) and (Red
                    <= US6.Rmax) and
                    (Green >= US6.Gmin) and (Green <= US6.Gmax) and
                    (Blue >= US6.Bmin) and (Blue <= US6.Bmax)) then
                  begin
                    inc(US6.Count);
                    US6.RValues := (US6.RValues + Red);
                    US6.GValues := (US6.GValues + Green);
                    US6.BValues := (US6.BValues + Blue);
                    Temp := ((US6.RValues div US6.Count) - CR); if
                    Temp < 0 then Temp := 0; US6.Rmin := Temp;
                    Temp := ((US6.RValues div US6.Count) + CR); if
                    Temp > 255 then Temp := 255; US6.Rmax := Temp;
                    Temp := ((US6.GValues div US6.Count) - CR); if
                    Temp < 0 then Temp := 0; US6.Gmin := Temp;
                    Temp := ((US6.GValues div US6.Count) + CR); if
                    Temp > 255 then Temp := 255; US6.Gmax := Temp;
                    Temp := ((US6.BValues div US6.Count) - CR); if
                    Temp < 0 then Temp := 0; US6.Bmin := Temp;
                    Temp := ((US6.BValues div US6.Count) + CR); if
                    Temp > 255 then Temp := 255; US6.Bmax := Temp;
                    Blue := GetBValue(MMT); Red := GetRValue(MMT);
                    Green := GetGValue(MMT);
                    lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^
                    := Red;
                  end else
                    if ((US7.Count > 0) and (Red >= US7.Rmin) and (Red
                      <= US7.Rmax) and
                      (Green >= US7.Gmin) and (Green <= US7.Gmax) and
                      (Blue >= US7.Bmin) and (Blue <= US7.Bmax)) then
                    begin
                      inc(US7.Count);
                      US7.RValues := (US7.RValues + Red);
                      US7.GValues := (US7.GValues + Green);
                      US7.BValues := (US7.BValues + Blue);
                      Temp := ((US7.RValues div US7.Count) - CR); if
                      Temp < 0 then Temp := 0; US7.Rmin := Temp;
                      Temp := ((US7.RValues div US7.Count) + CR); if
                      Temp > 255 then Temp := 255; US7.Rmax := Temp;
                      Temp := ((US7.GValues div US7.Count) - CR); if
                      Temp < 0 then Temp := 0; US7.Gmin := Temp;
                      Temp := ((US7.GValues div US7.Count) + CR); if
                      Temp > 255 then Temp := 255; US7.Gmax := Temp;
                      Temp := ((US7.BValues div US7.Count) - CR); if
                      Temp < 0 then Temp := 0; US7.Bmin := Temp;
                      Temp := ((US7.BValues div US7.Count) + CR); if
                      Temp > 255 then Temp := 255; US7.Bmax := Temp;
                      Blue := GetBValue(MMB); Red := GetRValue(MMB);
                      Green := GetGValue(MMB);
                      lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^
                      := Red;
                    end else
                      if ((US8.Count > 0) and (Red >= US8.Rmin) and
                        (Red <= US8.Rmax) and
                        (Green >= US8.Gmin) and (Green <= US8.Gmax)
                        and
                        (Blue >= US8.Bmin) and (Blue <= US8.Bmax))
                        then
                      begin
                        inc(US8.Count);
                        US8.RValues := (US8.RValues + Red);
                        US8.GValues := (US8.GValues + Green);
                        US8.BValues := (US8.BValues + Blue);
                        Temp := ((US8.RValues div US8.Count) - CR);
                          if
                        Temp < 0 then Temp := 0; US8.Rmin := Temp;
                        Temp := ((US8.RValues div US8.Count) + CR);
                          if
                        Temp > 255 then
                          Temp := 255; US8.Rmax := Temp;
                        Temp := ((US8.GValues div US8.Count) - CR);
                          if
                        Temp < 0 then Temp := 0; US8.Gmin := Temp;
                        Temp := ((US8.GValues div US8.Count) + CR);
                          if
                        Temp > 255 then
                          Temp := 255; US8.Gmax := Temp;
                        Temp := ((US8.BValues div US8.Count) - CR);
                          if
                        Temp < 0 then Temp := 0; US8.Bmin := Temp;
                        Temp := ((US8.BValues div US8.Count) + CR);
                          if
                        Temp > 255 then
                          Temp := 255; US8.Bmax := Temp;
                        Blue := GetBValue(MMU); Red :=
                        GetRValue(MMU);
                        Green := GetGValue(MMU);
                        lpPixelB^ := Blue; lpPixelG^ := Green;
                        lpPixelR^ := Red;
                      end else
                        if ((US9.Count > 0) and (Red >= US9.Rmin) and
                          (Red <= US9.Rmax) and
                          (Green >= US9.Gmin) and (Green <= US9.Gmax)
                          and
                          (Blue >= US9.Bmin) and (Blue <= US9.Bmax))
                          then
                        begin
                          inc(US9.Count);
                          US9.RValues := (US9.RValues + Red);
                          US9.GValues := (US9.GValues + Green);
                          US9.BValues := (US9.BValues + Blue);
                          Temp := ((US9.RValues div US9.Count) - CR);
                          if Temp < 0 then
                            Temp := 0; US9.Rmin := Temp;
                          Temp := ((US9.RValues div US9.Count) + CR);
                          if Temp > 255 then
                            Temp := 255; US9.Rmax := Temp;
                          Temp := ((US9.GValues div US9.Count) - CR);
                          if Temp < 0 then
                            Temp := 0; US9.Gmin := Temp;
                          Temp := ((US9.GValues div US9.Count) + CR);
                          if Temp > 255 then
                            Temp := 255; US9.Gmax := Temp;
                          Temp := ((US9.BValues div US9.Count) - CR);
                          if Temp < 0 then
                            Temp := 0; US9.Bmin := Temp;
                          Temp := ((US9.BValues div US9.Count) + CR);
                          if Temp > 255 then
                            Temp := 255; US9.Bmax := Temp;
                          Blue := GetBValue(MMS); Red :=
                          GetRValue(MMS);
                          Green := GetGValue(MMS);
                          lpPixelB^ := Blue; lpPixelG^ := Green;
                          lpPixelR^ := Red;
                        end else
                          if ((US10.Count > 0) and (Red >= US10.Rmin)
                            and (Red <= US10.Rmax) and
                            (Green >= US10.Gmin) and (Green <=
                            US10.Gmax) and
                            (Blue >= US10.Bmin) and (Blue <=
                            US10.Bmax)) then
                          begin
                            inc(US10.Count);
                            US10.RValues := (US10.RValues + Red);
                            US10.GValues := (US10.GValues + Green);
                            US10.BValues := (US10.BValues + Blue);
                            Temp := ((US10.RValues div US10.Count) -
                              CR); if Temp < 0 then
                              Temp := 0; US10.Rmin := Temp;
                            Temp := ((US10.RValues div US10.Count) +
                              CR); if Temp > 255 then
                              Temp := 255; US10.Rmax := Temp;
                            Temp := ((US10.GValues div US10.Count) -
                              CR); if Temp < 0 then
                              Temp := 0; US10.Gmin := Temp;
                            Temp := ((US10.GValues div US10.Count) +
                              CR); if Temp > 255 then
                              Temp := 255; US10.Gmax := Temp;
                            Temp := ((US10.BValues div US10.Count) -
                              CR); if Temp < 0 then
                              Temp := 0; US10.Bmin := Temp;
                            Temp := ((US10.BValues div US10.Count) +
                              CR); if Temp > 255 then
                              Temp := 255; US10.Bmax := Temp;
                            Blue := GetBValue(DLW); Red :=
                            GetRValue(DLW);
                            Green := GetGValue(DLW);
                            lpPixelB^ := Blue; lpPixelG^ := Green;
                            lpPixelR^ := Red;
                          end else
                            if ((US11.Count > 0) and (Red >=
                              US11.Rmin) and (Red <= US11.Rmax) and
                              (Green >= US11.Gmin) and (Green <=
                              US11.Gmax) and
                              (Blue >= US11.Bmin) and (Blue <=
                              US11.Bmax)) then
                            begin
                              inc(US11.Count);
                              US11.RValues := (US11.RValues + Red);
                              US11.GValues := (US11.GValues + Green);
                              US11.BValues := (US11.BValues + Blue);
                              Temp := ((US11.RValues div US11.Count)
                                - CR); if Temp < 0 then
                                Temp := 0; US11.Rmin := Temp;
                              Temp := ((US11.RValues div US11.Count)
                                + CR); if Temp > 255 then
                                Temp := 255; US11.Rmax := Temp;
                              Temp := ((US11.GValues div US11.Count)
                                - CR); if Temp < 0 then
                                Temp := 0; US11.Gmin := Temp;
                              Temp := ((US11.GValues div US11.Count)
                                + CR); if Temp > 255 then
                                Temp := 255; US11.Gmax := Temp;
                              Temp := ((US11.BValues div US11.Count)
                                - CR); if Temp < 0 then
                                Temp := 0; US11.Bmin := Temp;
                              Temp := ((US11.BValues div US11.Count)
                                + CR); if Temp > 255 then
                                Temp := 255; US11.Bmax := Temp;
                              Blue := GetBValue(LMW); Red :=
                              GetRValue(LMW);
                              Green := GetGValue(LMW);
                              lpPixelB^ := Blue; lpPixelG^ := Green;
                              lpPixelR^ := Red;
                            end else
                              if ((US12.Count > 0) and (Red >=
                                US12.Rmin) and (Red <= US12.Rmax) and
                                (Green >= US12.Gmin) and (Green <=
                                US12.Gmax) and
                                (Blue >= US12.Bmin) and (Blue <=
                                US12.Bmax)) then
                              begin
                                inc(US12.Count);
                                US12.RValues := (US12.RValues + Red);
                                US12.GValues := (US12.GValues +
                                  Green);
                                US12.BValues := (US12.BValues +
                                  Blue);
                                Temp := ((US12.RValues div US12.Count)
                                  - CR); if Temp < 0 then
                                  Temp := 0; US12.Rmin := Temp;
                                Temp := ((US12.RValues div US12.Count)
                                  + CR); if Temp > 255 then
                                  Temp := 255; US12.Rmax := Temp;
                                Temp := ((US12.GValues div US12.Count)
                                  - CR); if Temp < 0 then
                                  Temp := 0; US12.Gmin := Temp;
                                Temp := ((US12.GValues div US12.Count)
                                  + CR); if Temp > 255 then
                                  Temp := 255; US12.Gmax := Temp;
                                Temp := ((US12.BValues div US12.Count)
                                  - CR); if Temp < 0 then
                                  Temp := 0; US12.Bmin := Temp;
                                Temp := ((US12.BValues div US12.Count)
                                  + CR); if Temp > 255 then
                                  Temp := 255; US12.Bmax := Temp;
                                Blue := GetBValue(LMC); Red :=
                                GetRValue(LMC);
                                Green := GetGValue(LMC);
                                lpPixelB^ := Blue; lpPixelG^ :=
                                Green; lpPixelR^ := Red;
                              end else
                                if ((US13.Count > 0) and (Red >=
                                  US13.Rmin) and (Red <= US13.Rmax)
                                    and
                                  (Green >= US13.Gmin) and (Green <=
                                  US13.Gmax) and
                                  (Blue >= US13.Bmin) and (Blue <=
                                  US13.Bmax)) then
                                begin
                                  inc(US13.Count);
                                  US13.RValues := (US13.RValues +
                                    Red);
                                  US13.GValues := (US13.GValues +
                                    Green);
                                  US13.BValues := (US13.BValues +
                                    Blue);
                                  Temp := ((US13.RValues div
                                    US13.Count) - CR); if Temp < 0
                                      then
                                    Temp := 0; US13.Rmin := Temp;
                                  Temp := ((US13.RValues div
                                    US13.Count) + CR); if Temp > 255
                                  then
                                    Temp := 255; US13.Rmax := Temp;
                                  Temp := ((US13.GValues div
                                    US13.Count) - CR); if Temp < 0
                                      then
                                    Temp := 0; US13.Gmin := Temp;
                                  Temp := ((US13.GValues div
                                    US13.Count) + CR); if Temp > 255
                                  then
                                    Temp := 255; US13.Gmax := Temp;
                                  Temp := ((US13.BValues div
                                    US13.Count) - CR); if Temp < 0
                                      then
                                    Temp := 0; US13.Bmin := Temp;
                                  Temp := ((US13.BValues div
                                    US13.Count) + CR); if Temp > 255
                                  then
                                    Temp := 255; US13.Bmax := Temp;
                                  Blue := GetBValue(LMF); Red :=
                                  GetRValue(LMF);
                                  Green := GetGValue(LMF);
                                  lpPixelB^ := Blue; lpPixelG^ :=
                                  Green; lpPixelR^ := Red;
                                end else
                                  if ((US14.Count > 0) and (Red >=
                                    US14.Rmin) and (Red <= US14.Rmax)
                                    and
                                    (Green >= US14.Gmin) and (Green
                                    <= US14.Gmax) and
                                    (Blue >= US14.Bmin) and (Blue <=
                                    US14.Bmax)) then
                                  begin
                                    inc(US14.Count);
                                    US14.RValues := (US14.RValues +
                                      Red);
                                    US14.GValues := (US14.GValues +
                                      Green);
                                    US14.BValues := (US14.BValues +
                                      Blue);
                                    Temp := ((US14.RValues div
                                      US14.Count) - CR); if Temp < 0
                                    then
                                      Temp := 0; US14.Rmin := Temp;
                                    Temp := ((US14.RValues div
                                      US14.Count) + CR); if Temp > 255
                                    then
                                      Temp := 255; US14.Rmax := Temp;
                                    Temp := ((US14.GValues div
                                      US14.Count) - CR); if Temp < 0
                                    then
                                      Temp := 0; US14.Gmin := Temp;
                                    Temp := ((US14.GValues div
                                      US14.Count) + CR); if Temp > 255
                                    then
                                      Temp := 255; US14.Gmax := Temp;
                                    Temp := ((US14.BValues div
                                      US14.Count) - CR); if Temp < 0
                                    then
                                      Temp := 0; US14.Bmin := Temp;
                                    Temp := ((US14.BValues div
                                      US14.Count) + CR); if Temp > 255
                                    then
                                      Temp := 255; US14.Bmax := Temp;
                                    Blue := GetBValue(LMA); Red :=
                                    GetRValue(LMA);
                                    Green := GetGValue(LMA);
                                    lpPixelB^ := Blue; lpPixelG^ :=
                                    Green; lpPixelR^ := Red;
                                  end else
                                    if ((US15.Count > 0) and (Red >=
                                      US15.Rmin) and (Red <=
                                        US15.Rmax)
                                      and
                                      (Green >= US15.Gmin) and (Green
                                      <= US15.Gmax) and
                                      (Blue >= US15.Bmin) and (Blue
                                      <= US15.Bmax)) then
                                    begin
                                      inc(US15.Count);
                                      US15.RValues := (US15.RValues +
                                        Red);
                                      US15.GValues := (US15.GValues +
                                        Green);
                                      US15.BValues := (US15.BValues +
                                        Blue);
                                      Temp := ((US15.RValues div
                                        US15.Count) - CR); if Temp < 0
                                      then
                                        Temp := 0; US15.Rmin := Temp;
                                      Temp := ((US15.RValues div
                                        US15.Count) + CR); if Temp >
                                          255
                                      then
                                        Temp := 255; US15.Rmax :=
                                          Temp;
                                      Temp := ((US15.GValues div
                                        US15.Count) - CR); if Temp < 0
                                      then
                                        Temp := 0; US15.Gmin := Temp;
                                      Temp := ((US15.GValues div
                                        US15.Count) + CR); if Temp >
                                          255
                                      then
                                        Temp := 255; US15.Gmax :=
                                          Temp;
                                      Temp := ((US15.BValues div
                                        US15.Count) - CR); if Temp < 0
                                      then
                                        Temp := 0; US15.Bmin := Temp;
                                      Temp := ((US15.BValues div
                                        US15.Count) + CR); if Temp >
                                          255
                                      then
                                        Temp := 255; US15.Bmax :=
                                          Temp;
                                      Blue := GetBValue(LMR); Red :=
                                      GetRValue(LMR);
                                      Green := GetGValue(LMR);
                                      lpPixelB^ := Blue; lpPixelG^ :=
                                      Green; lpPixelR^ := Red;
                                    end else
                                      if ((US16.Count > 0) and (Red
                                        >= US16.Rmin) and (Red <=
                                        US16.Rmax) and
                                        (Green >= US16.Gmin) and
                                        (Green <= US16.Gmax) and
                                        (Blue >= US16.Bmin) and (Blue
                                        <= US16.Bmax)) then
                                      begin
                                        inc(US16.Count);
                                        US16.RValues := (US16.RValues
                                          + Red);
                                        US16.GValues := (US16.GValues
                                          + Green);
                                        US16.BValues := (US16.BValues
                                          + Blue);
                                        Temp := ((US16.RValues div
                                          US16.Count) - CR); if Temp
                                            < 0
                                        then
                                          Temp := 0; US16.Rmin :=
                                            Temp;
                                        Temp := ((US16.RValues div
                                          US16.Count) + CR); if Temp
                                            >
                                        255 then
                                          Temp := 255; US16.Rmax :=
                                        Temp;
                                        Temp := ((US16.GValues div
                                          US16.Count) - CR); if Temp
                                            < 0
                                        then
                                          Temp := 0; US16.Gmin :=
                                            Temp;
                                        Temp := ((US16.GValues div
                                          US16.Count) + CR); if Temp
                                            >
                                        255 then
                                          Temp := 255; US16.Gmax :=
                                        Temp;
                                        Temp := ((US16.BValues div
                                          US16.Count) - CR); if Temp
                                            < 0
                                        then
                                          Temp := 0; US16.Bmin :=
                                            Temp;
                                        Temp := ((US16.BValues div
                                          US16.Count) + CR); if Temp
                                            >
                                        255 then
                                          Temp := 255; US16.Bmax :=
                                        Temp;
                                        Blue := GetBValue(LMT); Red
                                        := GetRValue(LMT);
                                        Green := GetGValue(LMT);
                                        lpPixelB^ := Blue; lpPixelG^
                                        := Green; lpPixelR^ := Red;
                                      end else
                                        if ((US17.Count > 0) and (Red
                                          >= US17.Rmin) and (Red <=
                                          US17.Rmax) and
                                          (Green >= US17.Gmin) and
                                          (Green <= US17.Gmax) and
                                          (Blue >= US17.Bmin) and
                                          (Blue <= US17.Bmax)) then
                                        begin
                                          inc(US17.Count);
                                          US17.RValues :=
                                            (US17.RValues + Red);
                                          US17.GValues :=
                                            (US17.GValues + Green);
                                          US17.BValues :=
                                            (US17.BValues + Blue);
                                          Temp := ((US17.RValues div
                                            US17.Count) - CR); if Temp
                                          < 0 then
                                            Temp := 0; US17.Rmin :=
                                          Temp;
                                          Temp := ((US17.RValues div
                                            US17.Count) + CR); if Temp
                                          > 255 then
                                            Temp := 255; US17.Rmax :=
                                          Temp;
                                          Temp := ((US17.GValues div
                                            US17.Count) - CR); if Temp
                                          < 0 then
                                            Temp := 0; US17.Gmin :=
                                          Temp;
                                          Temp := ((US17.GValues div
                                            US17.Count) + CR); if Temp
                                          > 255 then
                                            Temp := 255; US17.Gmax :=
                                          Temp;
                                          Temp := ((US17.BValues div
                                            US17.Count) - CR); if Temp
                                          < 0 then
                                            Temp := 0; US17.Bmin :=
                                          Temp;
                                          Temp := ((US17.BValues div
                                            US17.Count) + CR); if Temp
                                          > 255 then
                                            Temp := 255; US17.Bmax :=
                                          Temp;
                                          Blue := GetBValue(LMB); Red
                                          := GetRValue(LMB);
                                          Green := GetGValue(LMB);
                                          lpPixelB^ := Blue; lpPixelG^
                                          := Green; lpPixelR^ := Red;
                                        end else
                                          if ((US18.Count > 0) and
                                            (Red >= US18.Rmin) and
                                              (Red
                                            <= US18.Rmax) and
                                            (Green >= US18.Gmin) and
                                            (Green <= US18.Gmax) and
                                            (Blue >= US18.Bmin) and
                                            (Blue <= US18.Bmax)) then
                                          begin
                                            inc(US18.Count);
                                            US18.RValues :=
                                              (US18.RValues + Red);
                                            US18.GValues :=
                                              (US18.GValues + Green);
                                            US18.BValues :=
                                              (US18.BValues + Blue);
                                            Temp := ((US18.RValues
                                              div
                                              US18.Count) - CR); if
                                                Temp
                                            < 0 then
                                              Temp := 0; US18.Rmin :=
                                            Temp;
                                            Temp := ((US18.RValues
                                              div
                                              US18.Count) + CR); if
                                                Temp
                                            > 255 then
                                              Temp := 255; US18.Rmax
                                                :=
                                            Temp;
                                            Temp := ((US18.GValues
                                              div
                                              US18.Count) - CR); if
                                                Temp
                                            < 0 then
                                              Temp := 0; US18.Gmin :=
                                            Temp;
                                            Temp := ((US18.GValues
                                              div
                                              US18.Count) + CR); if
                                                Temp
                                            > 255 then
                                              Temp := 255; US18.Gmax
                                                :=
                                            Temp;
                                            Temp := ((US18.BValues
                                              div
                                              US18.Count) - CR); if
                                                Temp
                                            < 0 then
                                              Temp := 0; US18.Bmin :=
                                            Temp;
                                            Temp := ((US18.BValues
                                              div
                                              US18.Count) + CR); if
                                                Temp
                                            > 255 then
                                              Temp := 255; US18.Bmax
                                                :=
                                            Temp;
                                            Blue := GetBValue(LMU);
                                            Red := GetRValue(LMU);
                                            Green := GetGValue(LMU);
                                            lpPixelB^ := Blue;
                                            lpPixelG^ := Green;
                                            lpPixelR^ := Red;
                                          end else
                                            if ((US19.Count > 0) and
                                              (Red >= US19.Rmin) and
                                              (Red <= US19.Rmax) and
                                              (Green >= US19.Gmin)
                                              and (Green <= US19.Gmax)
                                              and
                                              (Blue >= US19.Bmin) and
                                              (Blue <= US19.Bmax))
                                              then
                                            begin
                                              inc(US19.Count);
                                              US19.RValues :=
                                                (US19.RValues + Red);
                                              US19.GValues :=
                                                (US19.GValues +
                                                  Green);
                                              US19.BValues :=
                                                (US19.BValues +
                                                  Blue);
                                              Temp := ((US19.RValues
                                                div US19.Count) -
                                                  CR);
                                              if Temp < 0 then
                                                Temp := 0; US19.Rmin
                                                  :=
                                              Temp;
                                              Temp := ((US19.RValues
                                                div US19.Count) +
                                                  CR);
                                              if Temp > 255 then
                                                Temp := 255; US19.Rmax
                                              := Temp;
                                              Temp := ((US19.GValues
                                                div US19.Count) -
                                                  CR);
                                              if Temp < 0 then
                                                Temp := 0; US19.Gmin
                                                  :=
                                              Temp;
                                              Temp := ((US19.GValues
                                                div US19.Count) +
                                                  CR);
                                              if Temp > 255 then
                                                Temp := 255; US19.Gmax
                                              := Temp;
                                              Temp := ((US19.BValues
                                                div US19.Count) -
                                                  CR);
                                              if Temp < 0 then
                                                Temp := 0; US19.Bmin
                                                  :=
                                              Temp;
                                              Temp := ((US19.BValues
                                                div US19.Count) +
                                                  CR);
                                              if Temp > 255 then
                                                Temp := 255; US19.Bmax
                                              := Temp;
                                              Blue := GetBValue(LMS);
                                              Red := GetRValue(LMS);
                                              Green :=
                                                GetGValue(LMS);
                                              lpPixelB^ := Blue;
                                              lpPixelG^ := Green;
                                              lpPixelR^ := Red;
                                            end else
                                              if ((US20.Count > 0)
                                                and (Red >= US20.Rmin)
                                                and (Red <= US20.Rmax)
                                                and
                                                (Green >= US20.Gmin)
                                                and (Green <=
                                                US20.Gmax) and
                                                (Blue >= US20.Bmin)
                                                and (Blue <=
                                                US20.Bmax)) then
                                              begin
                                                inc(US20.Count);
                                                US20.RValues :=
                                                  (US20.RValues +
                                                    Red);
                                                US20.GValues :=
                                                  (US20.GValues +
                                                  Green);
                                                US20.BValues :=
                                                  (US20.BValues +
                                                  Blue);
                                                Temp := ((US20.RValues
                                                  div US20.Count) -
                                                  CR); if Temp < 0
                                                    then
                                                  Temp := 0; US20.Rmin
                                                := Temp;
                                                Temp := ((US20.RValues
                                                  div US20.Count) +
                                                  CR); if Temp > 255
                                                then
                                                  Temp := 255;
                                                    US20.Rmax
                                                := Temp;
                                                Temp := ((US20.GValues
                                                  div US20.Count) -
                                                  CR); if Temp < 0
                                                    then
                                                  Temp := 0; US20.Gmin
                                                := Temp;
                                                Temp := ((US20.GValues
                                                  div US20.Count) +
                                                  CR); if Temp > 255
                                                then
                                                  Temp := 255;
                                                    US20.Gmax
                                                := Temp;
                                                Temp := ((US20.BValues
                                                  div US20.Count) -
                                                  CR); if Temp < 0
                                                    then
                                                  Temp := 0; US20.Bmin
                                                := Temp;
                                                Temp := ((US20.BValues
                                                  div US20.Count) +
                                                  CR); if Temp > 255
                                                then
                                                  Temp := 255;
                                                    US20.Bmax
                                                := Temp;
                                                Blue :=
                                                  GetBValue(LLW); Red
                                                := GetRValue(LLW);
                                                Green :=
                                                  GetGValue(LLW);
                                                lpPixelB^ := Blue;
                                                lpPixelG^ := Green;
                                                lpPixelR^ := Red;
                                              end else


{IF THE PIXEL DOES NOT FIT ANYWHERE}


                                              begin
{Do a Min Distance if Booleaned OR Just Do the normal Count}
                                                if (Choice = 1) then
                                                begin

                                                  if (US1.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US1.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US1.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US1.BValues
                                                      - Blue)));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[1] :=
                                                      (RAll); end;
                                                  if (US2.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US2.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US2.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US2.BValues
                                                      - Blue)));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[2] :=
                                                      (RAll); end;
                                                  if (US3.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US3.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US3.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US3.BValues
                                                      - Blue)));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[3] :=
                                                      (RAll); end;
                                                  if (US4.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US4.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US4.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US4.BValues
                                                      - Blue)));
                                                    RAll := (RD + RG
                                                      + RB);
                                                    MinimumD[4] :=
                                                      (RAll); end;
                                                  if (US5.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US5.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US5.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US5.BValues
                                                      - Blue)));
                                                    RAll := (RD + RG
                                                      + RB);
                                                    MinimumD[5] :=
                                                      (RAll); end;
                                                  if (US6.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US6.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US6.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US6.BValues
                                                      - Blue)));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[6] :=
                                                      (RAll); end;
                                                  if (US7.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US7.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US7.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US7.BValues
                                                      - Blue)));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[7] :=
                                                      (RAll); end;
                                                  if (US8.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US8.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US8.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US8.BValues
                                                      - Blue)));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[8] :=
                                                      (RAll); end;
                                                  if (US9.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US9.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US9.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US9.BValues
                                                      - Blue)));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[9] :=
                                                      (RAll); end;
                                                  if (US10.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS(((US10.RValues
                                                      - Red)));
                                                    RG :=
                                                      ABS(((US10.GValues
                                                      - Green)));
                                                    RB :=
                                                      ABS(((US10.BValues
                                                      - Blue)));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[10] :=
                                                      (RAll); end;
                                                  if (US11.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS((US11.RValues
                                                      - Red));
                                                    RG :=
                                                      ABS((US11.GValues
                                                      - Green));
                                                    RB :=
                                                      ABS((US11.BValues
                                                      - Blue));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[11] :=
                                                      (RAll); end;
                                                  if (US12.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS((US12.RValues
                                                      - Red));
                                                    RG :=
                                                      ABS((US12.GValues
                                                      - Green));
                                                    RB :=
                                                      ABS((US12.BValues
                                                      - Blue));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[12] :=
                                                      (RAll); end;
                                                  if (US13.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS((US13.RValues
                                                      - Red));
                                                    RG :=
                                                      ABS((US13.GValues
                                                      - Green));
                                                    RB :=
                                                      ABS((US13.BValues
                                                      - Blue));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[13] :=
                                                      (RAll); end;
                                                  if (US14.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS((US14.RValues
                                                      - Red));
                                                    RG :=
                                                      ABS((US14.GValues
                                                      - Green));
                                                    RB :=
                                                      ABS((US14.BValues
                                                      - Blue));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[14] :=
                                                      (RAll); end;
                                                  if (US15.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS((US15.RValues
                                                      - Red));
                                                    RG :=
                                                      ABS((US15.GValues
                                                      - Green));
                                                    RB :=
                                                      ABS((US15.BValues
                                                      - Blue));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[15] :=
                                                      (RAll); end;
                                                  if (US16.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS((US16.RValues
                                                      - Red));
                                                    RG :=
                                                      ABS((US16.GValues
                                                      - Green));
                                                    RB :=
                                                      ABS((US16.BValues
                                                      - Blue));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[16] :=
                                                      (RAll); end;
                                                  if (US17.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS((US17.RValues
                                                      - Red));
                                                    RG :=
                                                      ABS((US17.GValues
                                                      - Green));
                                                    RB :=
                                                      ABS((US17.BValues
                                                      - Blue));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[17] :=
                                                      (RAll); end;
                                                  if (US18.Count > 0)
                                                    then begin
                                                    RD :=
                                                      ABS((US18.RValues
                                                      - Red));
                                                    RG :=
                                                      ABS((US18.GValues
                                                      - Green));
                                                    RB :=
                                                      ABS((US18.BValues
                                                      - Blue));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[18] :=
                                                      (RAll); end;
                                                  if (US19.Count > 0)
                                                    then begin
                                                    RD :=
                                                      (ABS(US19.RValues
                                                      - Red));
                                                    RG :=
                                                      (ABS(US19.GValues
                                                      - Green));
                                                    RB :=
                                                      (ABS(US19.BValues
                                                      - Blue));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[19] :=
                                                      (RAll); end;
                                                  if (US20.Count > 0)
                                                    then begin
                                                    RD :=
                                                      (ABS((US20.RValues
                                                      - Red)));
                                                    RG :=
                                                      (ABS((US20.GValues
                                                      - Green)));
                                                    RB :=
                                                      (ABS((US20.BValues
                                                      - Blue)));
                                                    RAll := RD + RG +
                                                      RB;
                                                    MinimumD[20] :=
                                                      (RAll); end;

                                                  InDistance :=
                                                    MinimumD[1];
                                                  Keeper := 1;
{Selects the min distance Class for the pixel}
                                                  for i := 2 to 20 do
                                                  begin
                                                    if (MinimumD[i] <
                                                      InDistance) then
                                                    begin Keeper :=
                                                      i; InDistance
                                                        :=
                                                      MinimumD[i];
                                                        end;
                                                  end;
                                                  case Keeper of
                                                    1: begin Blue :=
                                                        GetBValue(MMW);
                                                        Red :=
                                                          GetRValue(MMW);
                                                        Green :=
                                                          GetGValue(MMW);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    2: begin Blue :=
                                                        GetBValue(MMC);
                                                        Red :=
                                                          GetRValue(MMC);
                                                        Green :=
                                                          GetGValue(MMC);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    3: begin Blue :=
                                                        GetBValue(MMF);
                                                        Red :=
                                                          GetRValue(MMF);
                                                        Green :=
                                                          GetGValue(MMF);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    4: begin Blue :=
                                                        GetBValue(MMA);
                                                        Red :=
                                                          GetRValue(MMA);
                                                        Green :=
                                                          GetGValue(MMA);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    5: begin Blue :=
                                                        GetBValue(MMR);
                                                        Red :=
                                                          GetRValue(MMR);
                                                        Green :=
                                                          GetGValue(MMR);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    6: begin Blue :=
                                                        GetBValue(MMT);
                                                        Red :=
                                                          GetRValue(MMT);
                                                        Green :=
                                                          GetGValue(MMT);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    7: begin Blue :=
                                                        GetBValue(MMB);
                                                        Red :=
                                                          GetRValue(MMB);
                                                        Green :=
                                                          GetGValue(MMB);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    8: begin Blue :=
                                                        GetBValue(MMU);
                                                        Red :=
                                                          GetRValue(MMU);
                                                        Green :=
                                                          GetGValue(MMU);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    9: begin Blue :=
                                                        GetBValue(MMS);
                                                        Red :=
                                                          GetRValue(MMS);
                                                        Green :=
                                                          GetGValue(MMS);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    10: begin Blue :=
                                                        GetBValue(DLW);
                                                        Red :=
                                                          GetRValue(DLW);
                                                        Green :=
                                                          GetGValue(DLW);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    11: begin Blue :=
                                                        GetBValue(LMW);
                                                        Red :=
                                                          GetRValue(LMW);
                                                        Green :=
                                                          GetGValue(LMW);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    12: begin Blue :=
                                                        GetBValue(LMC);
                                                        Red :=
                                                          GetRValue(LMC);
                                                        Green :=
                                                          GetGValue(LMC);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    13: begin Blue :=
                                                        GetBValue(LMF);
                                                        Red :=
                                                          GetRValue(LMF);
                                                        Green :=
                                                          GetGValue(LMF);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    14: begin Blue :=
                                                        GetBValue(LMA);
                                                        Red :=
                                                          GetRValue(LMA);
                                                        Green :=
                                                          GetGValue(LMA);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    15: begin Blue :=
                                                        GetBValue(LMR);
                                                        Red :=
                                                          GetRValue(LMR);
                                                        Green :=
                                                          GetGValue(LMR);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    16: begin Blue :=
                                                        GetBValue(LMT);
                                                        Red :=
                                                          GetRValue(LMT);
                                                        Green :=
                                                          GetGValue(LMT);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    17: begin Blue :=
                                                        GetBValue(LMB);
                                                        Red :=
                                                          GetRValue(LMB);
                                                        Green :=
                                                          GetGValue(LMB);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    18: begin Blue :=
                                                        GetBValue(LMU);
                                                        Red :=
                                                          GetRValue(LMU);
                                                        Green :=
                                                          GetGValue(LMU);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    19: begin Blue :=
                                                        GetBValue(LMS);
                                                        Red :=
                                                          GetRValue(LMS);
                                                        Green :=
                                                          GetGValue(LMS);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                    20: begin Blue :=
                                                        GetBValue(LLW);
                                                        Red :=
                                                          GetRValue(LLW);
                                                        Green :=
                                                          GetGValue(LLW);
                                                        lpPixelB^ :=
                                                          Blue;
                                                        lpPixelG^ :=
                                                          Green;
                                                        lpPixelR^ :=
                                                          Red; end;
                                                  end;
                                                  inc(UnClassified.Count); {Keeps a record of how many  were unclassed}
                                                  UnClassified.RValues
                                                    :=
                                                    (UnClassified.RValues + Red);
                                                  UnClassified.GValues
                                                    :=
                                                    (UnClassified.GValues + Green);
                                                  UnClassified.BValues
                                                    :=
                                                    (UnClassified.BValues + Blue);
                                                end else
                                                begin
                                                  inc(UnClassified.Count);
                                                  UnClassified.RValues
                                                    :=
                                                    (UnClassified.RValues + Red);
                                                  UnClassified.GValues
                                                    :=
                                                    (UnClassified.GValues + Green);
                                                  UnClassified.BValues
                                                    :=
                                                    (UnClassified.BValues + Blue);
                                                  Blue :=
                                                    GetBValue(clFuchsia);
                                                  Red :=
                                                    GetRValue(clFuchsia);
                                                  Green :=
                                                    GetGValue(clFuchsia);
                                                  lpPixelB^ := Blue;
                                                  lpPixelG^ := Green;
                                                  lpPixelR^ := Red;
                                                end;
                                              end;
      end; {Column ... Pixel} end; {line}
{Load Stats into Memo}
{
ClassificationForm.CAMMemo.Lines.Add('Radius: '+sCR);
ClassificationForm.CAMMemo.Lines.Add('Distance: '+sSD);
ClassificationForm.CAMMemo.Lines.Add('Regroup: '+sRA);
ClassificationForm.CAMMemo.Lines.Add('Max Clusters: '+sMC);
Str(Seed,sSeed);
ClassificationForm.CAMMemo.Lines.Add('Seed : '+sSeed);
Str(US1.Count,S);S:='US 1 Count: '+S;CAMMemo.Lines.Add(S);
Str(US1.RValues,S);S:='US 1 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US1.GValues,S);S:='US 1 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US1.BValues,S);S:='US 1 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US1.Rmin,S);S:='US 1 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US1.Rmax,S);S:='US 1 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US1.Gmin,S);S:='US 1 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US1.Gmax,S);S:='US 1 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US1.Bmin,S);S:='US 1 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US1.Bmax,S);S:='US 1 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US2.Count,S);S:='US 2 Count: '+S;CAMMemo.Lines.Add(S);
Str(US2.RValues,S);S:='US 2 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US2.GValues,S);S:='US 2 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US2.BValues,S);S:='US 2 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US2.Rmin,S);S:='US 2 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US2.Rmax,S);S:='US 2 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US2.Gmin,S);S:='US 2 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US2.Gmax,S);S:='US 2 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US2.Bmin,S);S:='US 2 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US2.Bmax,S);S:='US 2 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US3.Count,S);  S:='US 3 Count: '+S;CAMMemo.Lines.Add(S);
Str(US3.RValues,S);S:='US 3 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US3.GValues,S);S:='US 3 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US3.BValues,S);S:='US 3 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US3.Rmin,S);   S:='US 3 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US3.Rmax,S);   S:='US 3 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US3.Gmin,S);   S:='US 3 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US3.Gmax,S);   S:='US 3 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US3.Bmin,S);   S:='US 3 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US3.Bmax,S);   S:='US 3 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US4.Count,S);  S:='US 4 Count: '+S;CAMMemo.Lines.Add(S);
Str(US4.RValues,S);S:='US 4 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US4.GValues,S);S:='US 4 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US4.BValues,S);S:='US 4 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US4.Rmin,S);   S:='US 4 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US4.Rmax,S);   S:='US 4 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US4.Gmin,S);   S:='US 4 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US4.Gmax,S);   S:='US 4 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US4.Bmin,S);   S:='US 4 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US4.Bmax,S);   S:='US 4 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US5.Count,S);  S:='US 5 Count: '+S;CAMMemo.Lines.Add(S);
Str(US5.RValues,S);S:='US 5 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US5.GValues,S);S:='US 5 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US5.BValues,S);S:='US 5 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US5.Rmin,S);   S:='US 5 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US5.Rmax,S);   S:='US 5 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US5.Gmin,S);   S:='US 5 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US5.Gmax,S);   S:='US 5 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US5.Bmin,S);   S:='US 5 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US5.Bmax,S);   S:='US 5 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US6.Count,S);  S:='US 6 Count: '+S;CAMMemo.Lines.Add(S);
Str(US6.RValues,S);S:='US 6 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US6.GValues,S);S:='US 6 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US6.BValues,S);S:='US 6 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US6.Rmin,S);   S:='US 6 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US6.Rmax,S);   S:='US 6 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US6.Gmin,S);   S:='US 6 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US6.Gmax,S);   S:='US 6 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US6.Bmin,S);   S:='US 6 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US6.Bmax,S);   S:='US 6 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US7.Count,S);  S:='US 7 Count: '+S;CAMMemo.Lines.Add(S);
Str(US7.RValues,S);S:='US 7 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US7.GValues,S);S:='US 7 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US7.BValues,S);S:='US 7 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US7.Rmin,S);   S:='US 7 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US7.Rmax,S);   S:='US 7 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US7.Gmin,S);   S:='US 7 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US7.Gmax,S);   S:='US 7 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US7.Bmin,S);   S:='US 7 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US7.Bmax,S);   S:='US 7 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US8.Count,S);  S:='US 8 Count: '+S;CAMMemo.Lines.Add(S);
Str(US8.RValues,S);S:='US 8 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US8.GValues,S);S:='US 8 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US8.BValues,S);S:='US 8 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US8.Rmin,S);   S:='US 8 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US8.Rmax,S);   S:='US 8 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US8.Gmin,S);   S:='US 8 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US8.Gmax,S);   S:='US 8 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US8.Bmin,S);   S:='US 8 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US8.Bmax,S);   S:='US 8 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US9.Count,S);  S:='US 9 Count: '+S;CAMMemo.Lines.Add(S);
Str(US9.RValues,S);S:='US 9 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US9.GValues,S);S:='US 9 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US9.BValues,S);S:='US 9 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US9.Rmin,S);   S:='US 9 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US9.Rmax,S);   S:='US 9 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US9.Gmin,S);   S:='US 9 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US9.Gmax,S);   S:='US 9 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US9.Bmin,S);   S:='US 9 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US9.Bmax,S);   S:='US 9 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US10.Count,S);  S:='US 10 Count: '+S;CAMMemo.Lines.Add(S);
Str(US10.RValues,S);S:='US 10 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US10.GValues,S);S:='US 10 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US10.BValues,S);S:='US 10 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US10.Rmin,S);   S:='US 10 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US10.Rmax,S);   S:='US 10 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US10.Gmin,S);   S:='US 10 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US10.Gmax,S);   S:='US 10 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US10.Bmin,S);   S:='US 10 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US10.Bmax,S);   S:='US 10 Bmax: '+S;CAMMemo.Lines.Add(S);


Str(US11.Count,S);  S:='US 11 Count: '+S;CAMMemo.Lines.Add(S);
Str(US11.RValues,S);S:='US 11 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US11.GValues,S);S:='US 11 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US11.BValues,S);S:='US 11 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US11.Rmin,S);   S:='US 11 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US11.Rmax,S);   S:='US 11 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US11.Gmin,S);   S:='US 11 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US11.Gmax,S);   S:='US 11 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US11.Bmin,S);   S:='US 11 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US11.Bmax,S);   S:='US 11 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US12.Count,S);  S:='US 12 Count: '+S;CAMMemo.Lines.Add(S);
Str(US12.RValues,S);S:='US 12 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US12.GValues,S);S:='US 12 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US12.BValues,S);S:='US 12 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US12.Rmin,S);   S:='US 12 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US12.Rmax,S);   S:='US 12 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US12.Gmin,S);   S:='US 12 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US12.Gmax,S);   S:='US 12 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US12.Bmin,S);   S:='US 12 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US12.Bmax,S);   S:='US 12 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US13.Count,S);  S:='US 13 Count: '+S;CAMMemo.Lines.Add(S);
Str(US13.RValues,S);S:='US 13 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US13.GValues,S);S:='US 13 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US13.BValues,S);S:='US 13 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US13.Rmin,S);   S:='US 13 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US13.Rmax,S);   S:='US 13 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US13.Gmin,S);   S:='US 13 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US13.Gmax,S);   S:='US 13 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US13.Bmin,S);   S:='US 13 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US13.Bmax,S);   S:='US 13 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US14.Count,S);  S:='US 14 Count: '+S;CAMMemo.Lines.Add(S);
Str(US14.RValues,S);S:='US 14 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US14.GValues,S);S:='US 14 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US14.BValues,S);S:='US 14 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US14.Rmin,S);   S:='US 14 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US14.Rmax,S);   S:='US 14 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US14.Gmin,S);   S:='US 14 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US14.Gmax,S);   S:='US 14 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US14.Bmin,S);   S:='US 14 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US14.Bmax,S);   S:='US 14 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US15.Count,S);  S:='US 15 Count: '+S;CAMMemo.Lines.Add(S);
Str(US15.RValues,S);S:='US 15 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US15.GValues,S);S:='US 15 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US15.BValues,S);S:='US 15 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US15.Rmin,S);   S:='US 15 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US15.Rmax,S);   S:='US 15 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US15.Gmin,S);   S:='US 15 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US15.Gmax,S);   S:='US 15 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US15.Bmin,S);   S:='US 15 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US15.Bmax,S);   S:='US 15 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US16.Count,S);  S:='US 16 Count: '+S;CAMMemo.Lines.Add(S);
Str(US16.RValues,S);S:='US 16 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US16.GValues,S);S:='US 16 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US16.BValues,S);S:='US 16 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US16.Rmin,S);   S:='US 16 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US16.Rmax,S);   S:='US 16 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US16.Gmin,S);   S:='US 16 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US16.Gmax,S);   S:='US 16 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US16.Bmin,S);   S:='US 16 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US16.Bmax,S);   S:='US 16 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US17.Count,S);  S:='US 17 Count: '+S;CAMMemo.Lines.Add(S);
Str(US17.RValues,S);S:='US 17 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US17.GValues,S);S:='US 17 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US17.BValues,S);S:='US 17 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US17.Rmin,S);   S:='US 17 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US17.Rmax,S);   S:='US 17 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US17.Gmin,S);   S:='US 17 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US17.Gmax,S);   S:='US 17 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US17.Bmin,S);   S:='US 17 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US17.Bmax,S);   S:='US 17 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US18.Count,S);  S:='US 18 Count: '+S;CAMMemo.Lines.Add(S);
Str(US18.RValues,S);S:='US 18 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US18.GValues,S);S:='US 18 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US18.BValues,S);S:='US 18 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US18.Rmin,S);   S:='US 18 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US18.Rmax,S);   S:='US 18 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US18.Gmin,S);   S:='US 18 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US18.Gmax,S);   S:='US 18 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US18.Bmin,S);   S:='US 18 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US18.Bmax,S);   S:='US 18 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US19.Count,S);  S:='US 19 Count: '+S;CAMMemo.Lines.Add(S);
Str(US19.RValues,S);S:='US 19 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US19.GValues,S);S:='US 19 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US19.BValues,S);S:='US 19 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US19.Rmin,S);   S:='US 19 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US19.Rmax,S);   S:='US 19 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US19.Gmin,S);   S:='US 19 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US19.Gmax,S);   S:='US 19 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US19.Bmin,S);   S:='US 19 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US19.Bmax,S);   S:='US 19 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(US20.Count,S);  S:='US 20 Count: '+S;CAMMemo.Lines.Add(S);
Str(US20.RValues,S);S:='US 20 Red Value: '+S;CAMMemo.Lines.Add(S);
Str(US20.GValues,S);S:='US 20 Green Value: '+S;CAMMemo.Lines.Add(S);
Str(US20.BValues,S);S:='US 20 Blue Value: '+S;CAMMemo.Lines.Add(S);
Str(US20.Rmin,S);   S:='US 20 Rmin: '+S;CAMMemo.Lines.Add(S);
Str(US20.Rmax,S);   S:='US 20 Rmax: '+S;CAMMemo.Lines.Add(S);
Str(US20.Gmin,S);   S:='US 20 Gmin: '+S;CAMMemo.Lines.Add(S);
Str(US20.Gmax,S);   S:='US 20 Gmax: '+S;CAMMemo.Lines.Add(S);
Str(US20.Bmin,S);   S:='US 20 Bmin: '+S;CAMMemo.Lines.Add(S);
Str(US20.Bmax,S);   S:='US 20 Bmax: '+S;CAMMemo.Lines.Add(S);

Str(UnClassified.Count,S);  S:='US Unc Count: '+S;CAMMemo.Lines.Add(S);
Str(UnClassified.RValues,S);S:='US Unc Red Value: '+S;CAMMemo.Lines.Add(S);
Str(UnClassified.GValues,S);S:='US Unc Green Value: '+S;CAMMemo.Lines.Add(S);
Str(UnClassified.BValues,S);S:='US Unc Blue Value: '+S;CAMMemo.Lines.Add(S);
}



{Place 2nd level Classifier Here (Min Distance...Classification Loop}
    case Choice of {Which Classifier}
      21: begin {Zero out Stuff} {Combine the Clusters}
          if (US1.Count > 1) then begin
            RD := (SQR((US1.RValues / US1.Count)));
            RG := (SQR((US1.GValues / US1.Count)));
            RB := (SQR((US1.BValues / US1.Count)));
            RAll := RD + RG + RB;
            MinimumD[1] := SQRT(RAll); end;
          if (US2.Count > 1) then begin
            RD := (SQR((US2.RValues / US2.Count)));
            RG := (SQR((US2.GValues / US2.Count)));
            RB := (SQR((US2.BValues / US2.Count)));
            RAll := RD + RG + RB;
            MinimumD[2] := SQRT(RAll); end;
          if (US3.Count > 1) then begin
            RD := (SQR((US3.RValues / US3.Count)));
            RG := (SQR((US3.GValues / US3.Count)));
            RB := (SQR((US3.BValues / US3.Count)));
            RAll := RD + RG + RB;
            MinimumD[3] := SQRT(RAll); end;
          if (US4.Count > 1) then begin
            RD := (SQR((US4.RValues / US4.Count)));
            RG := (SQR((US4.GValues / US4.Count)));
            RB := (SQR((US4.BValues / US4.Count)));
            RAll := RD + RG + RB;
            MinimumD[4] := SQRT(RAll); end;
          if (US5.Count > 1) then begin
            RD := (SQR((US5.RValues / US5.Count)));
            RG := (SQR((US5.GValues / US5.Count)));
            RB := (SQR((US5.BValues / US5.Count)));
            RAll := RD + RG + RB;
            MinimumD[5] := SQRT(RAll); end;
          if (US6.Count > 1) then begin
            RD := (SQR((US6.RValues / US6.Count)));
            RG := (SQR((US6.GValues / US6.Count)));
            RB := (SQR((US6.BValues / US6.Count)));
            RAll := RD + RG + RB;
            MinimumD[6] := SQRT(RAll); end;
          if (US7.Count > 1) then begin
            RD := (SQR((US7.RValues / US7.Count)));
            RG := (SQR((US7.GValues / US7.Count)));
            RB := (SQR((US7.BValues / US7.Count)));
            RAll := RD + RG + RB;
            MinimumD[7] := SQRT(RAll); end;
          if (US8.Count > 1) then begin
            RD := (SQR((US8.RValues / US8.Count)));
            RG := (SQR((US8.GValues / US8.Count)));
            RB := (SQR((US8.BValues / US8.Count)));
            RAll := RD + RG + RB;
            MinimumD[8] := SQRT(RAll); end;
          if (US9.Count > 1) then begin
            RD := (SQR((US9.RValues / US8.Count)));
            RG := (SQR((US9.GValues / US8.Count)));
            RB := (SQR((US9.BValues / US8.Count)));
            RAll := RD + RG + RB;
            MinimumD[9] := SQRT(RAll); end;

          if (US11.Count > 1) then begin
            RD := (SQR((US11.RValues / US11.Count)));
            RG := (SQR((US11.GValues / US11.Count)));
            RB := (SQR((US11.BValues / US11.Count)));
            RAll := RD + RG + RB;
            MinimumD[11] := SQRT(RAll); end;
          if (US12.Count > 1) then begin
            RD := (SQR((US12.RValues / US12.Count)));
            RG := (SQR((US12.GValues / US12.Count)));
            RB := (SQR((US12.BValues / US12.Count)));
            RAll := RD + RG + RB;
            MinimumD[12] := SQRT(RAll); end;
          if (US13.Count > 1) then begin
            RD := (SQR((US13.RValues / US13.Count)));
            RG := (SQR((US13.GValues / US13.Count)));
            RB := (SQR((US13.BValues / US13.Count)));
            RAll := RD + RG + RB;
            MinimumD[13] := SQRT(RAll); end;
          if (US14.Count > 1) then begin
            RD := (SQR((US14.RValues / US14.Count)));
            RG := (SQR((US14.GValues / US14.Count)));
            RB := (SQR((US14.BValues / US14.Count)));
            RAll := RD + RG + RB;
            MinimumD[14] := SQRT(RAll); end;
          if (US15.Count > 1) then begin
            RD := (SQR((US15.RValues / US15.Count)));
            RG := (SQR((US15.GValues / US15.Count)));
            RB := (SQR((US15.BValues / US15.Count)));
            RAll := RD + RG + RB;
            MinimumD[15] := SQRT(RAll); end;
          if (US16.Count > 1) then begin
            RD := (SQR((US16.RValues / US16.Count)));
            RG := (SQR((US16.GValues / US16.Count)));
            RB := (SQR((US16.BValues / US16.Count)));
            RAll := RD + RG + RB;
            MinimumD[16] := SQRT(RAll); end;
          if (US17.Count > 1) then begin
            RD := (SQR((US17.RValues / US17.Count)));
            RG := (SQR((US17.GValues / US17.Count)));
            RB := (SQR((US17.BValues / US17.Count)));
            RAll := RD + RG + RB;
            MinimumD[17] := SQRT(RAll); end;
          if (US18.Count > 1) then begin
            RD := (SQR((US18.RValues / US18.Count)));
            RG := (SQR((US18.GValues / US18.Count)));
            RB := (SQR((US18.BValues / US18.Count)));
            RAll := RD + RG + RB;
            MinimumD[18] := SQRT(RAll); end;
          if (US19.Count > 1) then begin
            RD := (SQR((US19.RValues / US19.Count)));
            RG := (SQR((US19.GValues / US19.Count)));
            RB := (SQR((US19.BValues / US19.Count)));
            RAll := RD + RG + RB;
            MinimumD[19] := SQRT(RAll); end;
          if (US10.Count > 1) then begin
            RD := (SQR((US10.RValues / US10.Count)));
            RG := (SQR((US10.GValues / US10.Count)));
            RB := (SQR((US10.BValues / US10.Count)));
            RAll := RD + RG + RB;
            MinimumD[10] := SQRT(RAll); end;
          if (US20.Count > 1) then begin
            RD := (SQR((US20.RValues / US20.Count)));
            RG := (SQR((US20.GValues / US20.Count)));
            RB := (SQR((US20.BValues / US20.Count)));
            RAll := RD + RG + RB;
            MinimumD[20] := SQRT(RAll); end;

          for i := 1 to 20 do
          begin
            for j := 1 to 20 do
            begin
              UCArray2020[i, j] := 0;
            end;
          end;
          for j := 1 to 20 do
          begin
            InDistance := MinimumD[j];
          end;
          for i := 1 to 20 do
          begin
            if ((((MinimumD[i]) + SD) > InDistance)
              and (((MinimumD[i]) - SD) < InDistance)) then
            begin
{    Str(InDistance:8:3,sCR);
    Str(MinimumD[i]:8:3,sSD);
     Str(j,SS);Str(i,S);
     UCArray2020[j,i]:= 1;
     CAMMemo.Lines.Add('Keeper:'+SS+':'+sCR+' : '+S+':'+sSD);}
              Keeper := i;
              InDistance := MinimumD[i];
            end; end;

          case Keeper of
            1: begin Blue := GetBValue(MMW); Red := GetRValue(MMW);
                Green := GetGValue(MMW);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            2: begin Blue := GetBValue(MMC); Red := GetRValue(MMC);
                Green := GetGValue(MMC);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            3: begin Blue := GetBValue(MMF); Red := GetRValue(MMF);
                Green := GetGValue(MMF);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            4: begin Blue := GetBValue(MMA); Red := GetRValue(MMA);
                Green := GetGValue(MMA);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            5: begin Blue := GetBValue(MMR); Red := GetRValue(MMR);
                Green := GetGValue(MMR);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            6: begin Blue := GetBValue(MMT); Red := GetRValue(MMT);
                Green := GetGValue(MMT);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            7: begin Blue := GetBValue(MMB); Red := GetRValue(MMB);
                Green := GetGValue(MMB);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            8: begin Blue := GetBValue(MMU); Red := GetRValue(MMU);
                Green := GetGValue(MMU);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            9: begin Blue := GetBValue(MMS); Red := GetRValue(MMS);
                Green := GetGValue(MMS);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            10: begin Blue := GetBValue(DLW); Red := GetRValue(DLW);
                Green := GetGValue(DLW);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            11: begin Blue := GetBValue(LMW); Red := GetRValue(LMW);
                Green := GetGValue(LMW);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            12: begin Blue := GetBValue(LMC); Red := GetRValue(LMC);
                Green := GetGValue(LMC);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            13: begin Blue := GetBValue(LMF); Red := GetRValue(LMF);
                Green := GetGValue(LMF);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            14: begin Blue := GetBValue(LMA); Red := GetRValue(LMA);
                Green := GetGValue(LMA);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            15: begin Blue := GetBValue(LMR); Red := GetRValue(LMR);
                Green := GetGValue(LMR);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            16: begin Blue := GetBValue(LMT); Red := GetRValue(LMT);
                Green := GetGValue(LMT);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            17: begin Blue := GetBValue(LMB); Red := GetRValue(LMB);
                Green := GetGValue(LMB);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            18: begin Blue := GetBValue(LMU); Red := GetRValue(LMU);
                Green := GetGValue(LMU);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            19: begin Blue := GetBValue(LMS); Red := GetRValue(LMS);
                Green := GetGValue(LMS);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
            20: begin Blue := GetBValue(LLW); Red := GetRValue(LLW);
                Green := GetGValue(LLW);
                lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
                Red; end;
          else begin
{  inc(UnClassified.Count);
  UnClassified.RValues:= (UnClassified.RValues + Red);
  UnClassified.GValues:= (UnClassified.GValues + Green);
  UnClassified.BValues:= (UnClassified.BValues + Blue);  }
              Blue := GetBValue(clFuchsia);
              Red := GetRValue(clFuchsia);
              Green := GetGValue(clFuchsia);
              lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ :=
              Red;
            end;
          end;


{Run a Regroup.. or just the white pixels of Image with RGB data from Undo}
   // Calculate the address of row in image data
(*    for Row:=0 to ImageHeight do Begin
    Per_Done:= Round(100 * (Row /(ImageHeight)));
    SetP_Done1(Per_Done);
    Line := (Row * BytesPerLine);
    // Calculate the address of desired pixel
    for Col:=0 to ImageWidth do Begin
      Where:= (Line + (Col * 3));
      lpPixelB := @PHugeByteArray(Undo)^[Where];
      lpPixelG := @PHugeByteArray(Undo)^[Where+1];
      lpPixelR := @PHugeByteArray(Undo)^[Where+2];
      Blue  := lpPixelB^ ;
      Green := lpPixelG^ ;
      Red   := lpPixelR^;
      lpPixelB := @PHugeByteArray(Image)^[Where];
      lpPixelG := @PHugeByteArray(Image)^[Where+1];
      lpPixelR := @PHugeByteArray(Image)^[Where+2];

If ((Red >= US20.Rmin) and (Red <= US20.Rmax)and
(Green >= US20.Gmin) and (Green <= US20.Gmax)and
(Blue >= US20.Bmin) and (Blue <= US20.Bmax)) then
Begin
  inc(US20.Count);
  US20.RValues:= (US20.RValues + Red);
  US20.GValues:= (US20.GValues + Green);
  US20.BValues:= (US20.BValues + Blue);
Temp:=((US20.RValues div US20.Count)-15);If Temp<0 then Temp:=0;     US20.Rmin:=Temp;
Temp:=((US20.RValues div US20.Count)+15);If Temp>255 then Temp:=255; US20.Rmax:=Temp;
Temp:=((US20.GValues div US20.Count)-15);If Temp<0 then Temp:=0;     US20.Gmin:=Temp;
Temp:=((US20.GValues div US20.Count)+15);If Temp>255then Temp:=255;  US20.Gmax:=Temp;
Temp:=((US20.BValues div US20.Count)-15);If Temp<0 then Temp:=0;     US20.Bmin:=Temp;
Temp:=((US20.BValues div US20.Count)+15);If Temp>255 then Temp:=255; US20.Bmax:=Temp;
Blue:=GetBValue(LLS);Red:=GetRValue(LLS);
Green:=GetGValue(LLS);
 lpPixelB^ := Blue; lpPixelG^ := Green; lpPixelR^ := Red;
End;

End;End;
*)
        end;
    end; {of case}
    SetImage;
{SET the data into the ARRAY format}

{Call Set?? to place data into form}
    ClassificationForm.SetDataIntoForm(10);
  end;
{$IFDEF CKRANGE}
{$UNDEF CKRANGE}
{$R+}
{$ENDIF}
end;
//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////

end.
